//take a seat, young Skywalker
#include <iostream>
#include <cstdint>
#include <algorithm>
#include <vector>

struct Person {
	uint32_t a, b;
	Person(uint32_t a = 0, uint32_t b = 0): a(a), b(b) {}

	static bool compare_a(const Person &a, const Person &b) {
		return a.a > b.a;
	}
};

std::vector<Person> people;

uint64_t l;

void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t n;
	std::cin >> n >> l;
	people.resize(n);
	for (Person &i : people) {
		std::cin >> i.a >> i.b;
	}
}

uint64_t solve_1() {
	uint64_t ans = 0;
	for (const Person &p : people) {
		uint64_t cur = p.a + p.b * (l - 1);
		ans = std::max(ans, cur);
	}
	return ans;
}

uint64_t solve_k(uint32_t k) {
	if (k > l) {
		return 0;
	}
	if (k == 1) {
		return solve_1();
	}

	uint64_t baseS = 0;

	uint32_t s1 = 0, s2 = 0;
	uint64_t b1 = 0, b2 = 0;

	for (uint32_t i = 0;i < k;i++) {
		baseS += people[i].a;
		uint64_t cB = (l - k) * people[i].b;
		if (cB > b1) {
			b2 = b1;
			s2 = s1;

			b1 = cB;
			s1 = i;
		} else if (cB > b2) {
			b2 = cB;
			s2 = i;
		}
	}


	uint64_t bb1 = 0, bb2 = 0;
	for (uint32_t i = k;i < people.size();i++) {
		uint64_t cB = (l - k) * people[i].b + people[i].a;

		if (cB > bb1) {
			bb2 = bb1;
			bb1 = cB;
		} else if (cB > bb2) {
			bb2 = cB;
		}
	}
	

	//no swap
	uint64_t ans = b1 + b2 + baseS;

	uint64_t cur;

	//swap both
	cur = baseS;
	cur -= people[k - 1].a + people[k - 2].a;
	cur += bb1 + bb2;
	ans = std::max(ans, cur);

	//swap one with bottom
	cur = baseS;
	cur -= people[k - 1].a;
	cur += bb1;
	if (s1 != k - 1) {
		cur += b1;
	} else {
		cur += b2;
	}
	ans = std::max(ans, cur);

	//swap one with second bottom;
	cur = baseS;
	cur -= people[k - 2].a;
	cur += bb1;
	if (s1 != k - 2) {
		cur += b1;
	} else {
		cur += b2;
	}
	ans = std::max(ans, cur);


	return ans;
}


int main() {
	input();
	std::sort(people.begin(), people.end(), Person::compare_a);
	for (uint32_t i = 1;i <= people.size();i++) {
		std::cout << solve_k(i) << "\n";
	}
}



