#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (142);

vector<int> dx = {-1, -1, -2, -2, 1, 1, 2, 2};
vector<int> dy = {2, -2, -1, 1, -2, 2, 1, -1};

int n, m, k;
string a[MAXN];

bool valid(int x, int y) { return x >= 0 && y >= 0 && x < n && y < m && a[x][y] == '.'; }

void read()
{
    cin >> n >> m >> k;
    for(int i = 0; i < n; i++)
        cin >> a[i];
}

set<int> cnt[MAXN][MAXN];
int psum[MAXN][MAXN], sum[MAXN][MAXN];

void solve()
{
    vector<pair<int, int> > valid_cells;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            if(valid(i, j))
                valid_cells.push_back({i, j});

    vector<pair<int, int> > answer;
    set<pair<int, pair<int, int> > > st;

    for(auto it: valid_cells)
    {
        int i = it.first, j = it.second;
        st.insert({1, {i, j}});
        cnt[i][j].insert(0);
        sum[i][j] = 1;
    }

    while(!st.empty())
    {
        auto it = prev(st.end());

        if(it->first == 0)
            break;

        int i = it->second.first, j = it->second.second;
        answer.push_back({i, j});
        st.erase(it);
        st.insert({0, {i, j}});
        sum[i][j] = 0;

        for(int d = 0; d < 8; d++)
        {
            int nx = i + dx[d], ny = j + dy[d];
            if(!valid(nx, ny)) continue;
            psum[nx][ny] = sum[nx][ny];
        }

        for(int d = 0; d < 8; d++)
        {
            int nx = i + dx[d], ny = j + dy[d];
            if(!valid(nx, ny)) continue;
            for(auto q: cnt[i][j])
                if(q < k) cnt[nx][ny].insert(q + 1);

            sum[nx][ny] = SZ(cnt[nx][ny]);
        }

        for(int d = 0; d < 8; d++)
        {
            int nx = i + dx[d], ny = j + dy[d];
            if(!valid(nx, ny)) continue;
            if(psum[nx][ny] != sum[nx][ny])
            {
                st.erase({psum[nx][ny], {nx, ny}});
                st.insert({sum[nx][ny], {nx, ny}});
            }
        }

        cnt[i][j].clear();
    }

    cout << SZ(answer) << endl;
    for(auto it: answer) cout << it.first << " " << it.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
