#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back
#pragma GCC optimize("O3")

using namespace std;
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (int)1e5 + 42;
const int64_t inf = (int64_t)1e18;
const int B = 200;

struct convex_hull_trick
{
    struct line
    {
        int64_t a, b;
        long double nxt_x;
        int64_t value(int64_t x) { return a * x + b; }

        line() { a = b = nxt_x = 0; }
        line(int64_t _a, int64_t _b)
        {
            a = _a;
            b = _b;
            nxt_x = inf;
        }
    };

    long double intersect_x(line a, line b) { return (a.b - b.b) / (long double)(b.a - a.a); }

    vector<line> cht;
    void add_line(int a, int b)
    {
        if(SZ(cht))
            if(cht.back().a == a)
            {
                if(cht.back().b > b) return;
                else
                {
                    cht.pop_back();
                    cht.push_back(line(a, b));
                    return;
                }
            }

        line curr = line(a, b);
        while(SZ(cht) >= 2 && intersect_x(curr, cht[SZ(cht) - 2]) <= intersect_x(cht[SZ(cht) - 1], cht[SZ(cht) - 2]))
            cht.pop_back();

        if(SZ(cht)) cht[SZ(cht) - 1].nxt_x = intersect_x(cht.back(), curr);
        cht.push_back(curr);
    }

    int64_t query(int64_t x)
    {
        int low = 0, high = SZ(cht) - 1, mid, ret;

        while(low <= high)
        {
            mid = (low + high) >> 1;
            if(x <= cht[mid].nxt_x)
                ret = mid, high = mid - 1;
            else
                low = mid + 1;
        }

        return cht[ret].value(x);
    }
};

int n, l;
pair<int, int> a[MAXN];

void read()
{
    cin >> n >> l;
    for(int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
}

int64_t answer[MAXN * 2];
int m;

convex_hull_trick cht[MAXN / B + 42];

int64_t query_max1(int start, int at_x)
{
    int64_t answer = 0;
    while(start % B && start < n)
    {
        chkmax(answer, a[start].first + a[start].second * 1ll * at_x);
        start++;
    }

    for(int i = start, bk = start / B; i < n; i += B, bk++)
        chkmax(answer, cht[bk].query(at_x));

    return answer;
}

void fix2(vector<int64_t> &l)
{
    sort(l.rbegin(), l.rend());
    if(SZ(l) > 2) l.pop_back();
}

int64_t query_max2(int start, int at_x)
{
    vector<int64_t> cands;

    while(start % B && start < n)
    {
        cands.push_back(a[start].first + a[start].second * 1ll * at_x);
        fix2(cands);
        start++;
    }

    pair<int64_t, int> mx = {-1, -1};
    vector<pair<int64_t, int> > ah;
    for(int i = start, bk = start / B; i < n; i += B, bk++)
    {
        auto it = make_pair(cht[bk].query(at_x), bk);
        ah.push_back(it);
        chkmax(mx, it);
    }

    if(mx.second != -1)
    {
        int l = mx.second * B, r = min(l + B - 1, n);
        for(int i = l; i <= r; i++)
        {
            cands.push_back(a[i].first + a[i].second * 1ll * at_x);
            fix2(cands);
        }
    }

    for(auto it: ah)
        if(it != mx)
        {
            cands.push_back(it.first);
            fix2(cands);
        }

    return cands[SZ(cands) - 1] + cands[SZ(cands) - 2];
}

void solve()
{
    for(int i = 1; i <= n; i++)
        answer[i] = 0;

    m = min(n, l);

    sort(a, a + n);
    reverse(a, a + n);

    for(int i = 0; i < n; i++)
        chkmax(answer[1], a[i].first + a[i].second * 1ll * (l - 1));

    vector<int> curr_max;

    int64_t sum_a = 0;
    for(int i = 0; i < m; i++)
    {
        sum_a += a[i].first;
        curr_max.pb(a[i].second);

        sort(ALL(curr_max));
        reverse(ALL(curr_max));
        if(SZ(curr_max) > 2)
            curr_max.pop_back();

        if(i >= 1)
            chkmax(answer[i + 1], sum_a + (l - i - 1) * 1ll * (curr_max[0] + curr_max[1]));
    }

    for(int i = 0; i < n; i += B)
    {
        int l = i, r = min(n - 1, i + B - 1), id = i / B;

        vector<pair<int, int> > vec;
        for(int j = l; j <= r; j++)
            vec.pb({a[j].second, a[j].first});

        sort(ALL(vec));
        for(auto it: vec)
            cht[id].add_line(it.first, it.second);
    }

    int mx = 0;
    sum_a = 0;
    for(int i = -1; i + 1 < m; i++)
    {
        if(i != -1)
        {
            chkmax(mx, a[i].second);
            sum_a += a[i].first;
        }

        /*
        int64_t mx2 = 0;
        vector<int64_t> mx_li;
        for(int j = i + 1; j < n; j++)
        {
            mx_li.pb(a[j].first + a[j].second * 1ll * (l - i - 3));

            sort(ALL(mx_li));
            reverse(ALL(mx_li));
            if(SZ(mx_li) > 2)
                mx_li.pop_back();

            chkmax(mx2, a[j].first + a[j].second * 1ll * (l - i - 2));
        }*/

        if(i + 3 <= l && i + 2 < n) chkmax(answer[i + 3], sum_a + query_max2(i + 1, l - i - 3));
        if(i != -1) chkmax(answer[i + 2], sum_a + mx * 1ll * (l - i - 2) + query_max1(i + 1, (l - i - 2)));
            //chkmax(answer[i + 2], sum_a + mx * 1ll * (l - i - 2) + mx2);
    }

    for(int i = 1; i <= n; i++)
        cout << answer[i] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
