#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (int)1e5 + 42;
const int64_t inf = (int64_t)1e18;
const int B = 600;

//int read_int();

struct convex_hull_trick
{
    struct line
    {
        int64_t a, b;
        double nxt_x;
        int64_t value(int64_t x) { return a * x + b; }

        line() { a = b = nxt_x = 0; }
        line(int64_t _a, int64_t _b)
        {
            a = _a;
            b = _b;
            nxt_x = inf;
        }
    };

    double intersect_x(line a, line b) { return (a.b - b.b) / (double)(b.a - a.a); }

    vector<line> cht;
    int64_t qans[MAXN * 2];

    void init(int mx)
    {
        int po = 0;
        for(int v = 0; v <= mx; v++)
        {
            while(cht[po].nxt_x < v) po++;
            qans[v] = cht[po].value(v);
        }
    }

    void add_line(int a, int b)
    {
        if(SZ(cht))
            if(cht.back().a == a)
            {
                if(cht.back().b > b) return;
                else
                {
                    cht.pop_back();
                    cht.push_back(line(a, b));
                    return;
                }
            }

        line curr = line(a, b);
        while(SZ(cht) >= 2 && intersect_x(curr, cht[SZ(cht) - 2]) <= intersect_x(cht[SZ(cht) - 1], cht[SZ(cht) - 2]))
            cht.pop_back();

        if(SZ(cht)) cht[SZ(cht) - 1].nxt_x = intersect_x(cht.back(), curr);
        cht.push_back(curr);
    }

    int64_t query(int x)
    {
        return qans[x];

        int low = 0, high = SZ(cht) - 1, mid, ret;

        while(low <= high)
        {
            mid = (low + high) >> 1;
            if(x <= cht[mid].nxt_x)
                ret = mid, high = mid - 1;
            else
                low = mid + 1;
        }

        return cht[ret].value(x);
    }
};

int n, l;
pair<int, int> a[MAXN];

void read()
{
    cin >> n >> l;
    for(int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
}

int64_t answer[MAXN * 2];
int m;

convex_hull_trick cht[500];

int64_t query_max1(int start, int at_x)
{
    int64_t answer = 0;
    while(start % B && start < n)
    {
        chkmax(answer, a[start].first + a[start].second * 1ll * at_x);
        start++;
    }

    for(int i = start, bk = start / B; i < n; i += B, bk++)
        chkmax(answer, cht[bk].query(at_x));

    return answer;
}

void fix2(vector<int64_t> &l)
{
    sort(l.rbegin(), l.rend());
    if(SZ(l) > 2) l.pop_back();
}

void fix(pair<int64_t, int64_t> &mx, int64_t val)
{
    if(mx.first == -1) mx.first = val;
    else
    {
        chkmax(mx.second, val);
        if(mx.first < mx.second)
            swap(mx.first, mx.second);
    }
}

int64_t last_val[MAXN];

int64_t query_max2(int start, int at_x)
{
    pair<int64_t, int64_t> mx = {-1, -1};
    while(start % B && start < n)
    {
        fix(mx, a[start].first + a[start].second * 1ll * at_x);
        start++;
    }

    pair<int64_t, int> mxx = {-1, -1};
    for(int i = start, bk = start / B; i < n; i += B, bk++)
    {
        auto it = make_pair(cht[bk].query(at_x), bk);
        last_val[bk] = it.first;
        chkmax(mxx, it);
    }

    for(int i = start, bk = start / B; i < n; i += B, bk++)
        if(mxx.second != bk) fix(mx, last_val[bk]);

    if(mxx.second != -1)
    {
        int l = mxx.second * B;
        int r = min(l + B - 1, n);
        for(int i = l; i <= r; i++)
            fix(mx, a[i].first + a[i].second * 1ll * at_x);
    }

    return mx.first + mx.second;
}

void solve()
{
    for(int i = 1; i <= n; i++)
        answer[i] = 0;

    m = min(n, l);

    sort(a, a + n);
    reverse(a, a + n);

    for(int i = 0; i < n; i++)
        chkmax(answer[1], a[i].first + a[i].second * 1ll * (l - 1));

    vector<int> curr_max;

    int64_t sum_a = 0;
    for(int i = 0; i < m; i++)
    {
        sum_a += a[i].first;
        curr_max.pb(a[i].second);

        sort(ALL(curr_max));
        reverse(ALL(curr_max));
        if(SZ(curr_max) > 2)
            curr_max.pop_back();

        if(i >= 1)
            chkmax(answer[i + 1], sum_a + (l - i - 1) * 1ll * (curr_max[0] + curr_max[1]));
    }

    for(int i = 0; i < n; i += B)
    {
        int l = i, r = min(n - 1, i + B - 1), id = i / B;

        vector<pair<int, int> > vec;
        for(int j = l; j <= r; j++)
            vec.pb({a[j].second, a[j].first});

        sort(ALL(vec));
        for(auto it: vec)
            cht[id].add_line(it.first, it.second);

        cht[id].init(::l);
    }

    int mx = 0;
    sum_a = 0;
    for(int i = -1; i + 1 < m; i++)
    {
        if(i != -1)
        {
            chkmax(mx, a[i].second);
            sum_a += a[i].first;
        }

        if(i + 3 <= l && i + 2 < n) chkmax(answer[i + 3], sum_a + query_max2(i + 1, l - i - 3));
        if(i != -1) chkmax(answer[i + 2], sum_a + mx * 1ll * (l - i - 2) + query_max1(i + 1, (l - i - 2)));
    }

    for(int i = 1; i <= n; i++)
        cout << answer[i] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
