#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e2 + 5;

int n, m, k;
char tab[N][N];
bool vis[N][N];

vector <pair <int, int> > ans_v;
int ans_sz;
pair <int, int> answer[(int)1e7];

bool cool(int x, int y)
{
    if(x < 1 || x > n || y < 1 || y > m)
        return false;
    if(vis[x][y])
        return false;
    return (tab[x][y] == '.');
}

bool clean()
{
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            if(tab[i][j] == '#')
                return false;
    return true;
}



int dx[8] = {1, 1, -1, -1, 2, 2, -2, -2};
int dy[8] = {2, -2, 2, -2, 1, -1, 1, -1};

void solve_clean(vector <pair <int, int> > c[2])
{
    if(c[0].size() > c[1].size())
        swap(c[0], c[1]);

    for(int i = 0; i <= k + 1; i++)
    {
        int id = (i & 1);
        for(auto x: c[id])
            ans_v.pb(x);
    }

    printf("%d\n", (int)ans_v.size());
    for(auto x: ans_v)
        printf("%d %d\n", x.first - 1, x.second - 1);
}


vector <pair <int, int> > c[2]; /// black and white
bool w[N][N];

int comps;
pair <int, int> col[2][N * N];
int sz[2];

void DFS(int x, int y)
{
    vis[x][y] = true;
    sz[w[x][y]]++;
    col[w[x][y]][sz[w[x][y]]] = {x, y};

    for(int i = 0; i < 8; i++)
    {
        if(cool(x + dx[i], y + dy[i]))
            DFS(x + dx[i], y + dy[i]);
    }
}

void clean_comp()
{
    if(sz[0] > sz[1])
    {
        swap(sz[0], sz[1]);
        swap(col[0], col[1]);
    }

    if(sz[0] == 0)
    {
        ans_sz++;
        answer[ans_sz] = col[1][1];

        return;
    }

    for(int i = 0; i <= k + 1; i++)
    {
        int id = (i & 1);
        for(int j = 1; j <= sz[id]; j++)
        {
            pair <int, int> x = col[id][j];
            ans_sz++;
            answer[ans_sz] = x;
        }
    }
}

void dumb_solve()
{
    int alive = 0;
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
        {
            if(tab[i][j] == '.')
                alive++;
        }

    printf("%d\n", alive);
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
        {
            if(tab[i][j] == '.')
                printf("%d %d\n", i - 1, j - 1);
        }
}


int main()
{
    //ios_base::sync_with_stdio(false);
   // cin.tie(nullptr); cout.tie(nullptr);

    cin >> n >> m >> k;
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            cin >> tab[i][j];

   for(int i = 1; i <= n; i++)
    {
        int white;
        if(i & 1)
            white = 1;
        else
            white = 0;
        for(int j = 1; j <= m; j++)
        {
            w[i][j] = white;

            if(tab[i][j] == '.')
                c[white].pb({i, j});
            white ^= 1;
        }
    }

   /* if(clean())
    {
        solve_clean(c);
        return 0;
    } */


    if(n == 1 || m == 1)
    {
        dumb_solve();
        return 0;
    }

    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            if(cool(i, j))
            {
               // cerr << i << " " << j << " IJ " << endl;

                comps++;
                sz[0] = sz[1] = 0;
                DFS(i, j);

                clean_comp();
            }
        }
    }

   /* printf("%d\n", (int)ans_v.size());
    for(auto x: ans_v)
        printf("%d %d\n", x.first - 1, x.second - 1); */


    printf("%d\n", ans_sz);
    for(int i = 1; i <= ans_sz; i++)
        printf("%d %d\n", answer[i].first - 1, answer[i].second - 1);



    return 0;
}

/*

3 3 1
...
...
...

*/

/*

3 5 1
.....
#####
.#.#.

*/


/*

2 4 2
....
###.

*/
