#include <iostream>
#include <vector>
#include <queue>
using namespace std;

const int MAXN = 128;

struct state
{
    int x, y, z;
    state(){}
    state(int x, int y, int z)
    {
        this -> x = x;
        this -> y = y;
        this -> z = z;
    }
};

bool operator<(state x, state y)
{
    return x.z < y.z;
}

int dir[8][2] = {{+1, -2}, {+1, +2}, {-1, -2}, {-1, +2}, {+2, -1}, {+2, +1}, {-2, -1}, {-2, +1}};

int n, m, k;
int a[MAXN][MAXN];

long long cnt = 0;
int dp[MAXN][MAXN];
priority_queue<state> pq;

int main()
{
    cin >> n >> m >> k;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = 0; j < m; ++ j)
        {
            char ch;
            cin >> ch;
            if (ch == '.')
            {
                a[i][j] = 0;
            }
            else a[i][j] = 1;
        }
    }

    for (int i = 0; i < n; ++ i)
    {
        for (int j = 0; j < m; ++ j)
        {
            if (a[i][j]) continue;

            bool is = 0;
            for (int d = 0; d < 8; ++ d)
            {
                int ni = i + dir[d][0];
                int nj = j + dir[d][1];

                if (ni >= 0 and nj >= 0 and ni < n and nj < m and a[ni][nj] == 0)
                {
                    is = true;
                    break;
                }
            }

            if (!is)
            {
                a[i][j] = 1;
                cnt++;
            }
            else
            {
                dp[i][j] = k;
                pq.emplace(i, j, k);
            }
        }
    }

    while (!pq.empty())
    {
        state t = pq.top();
        pq.pop();

        cout << t.x << ' ' << t.y << ' ' << t.z << endl;

        int i = t.x;
        int j = t.y;
        int nk = -3;

        for (int d = 0; d < 8; ++ d)
        {
            int ni = i + dir[d][0];
            int nj = j + dir[d][1];

            if (ni >= 0 and nj >= 0 and ni < n and nj < m and a[ni][nj] == 0)
            {
                nk = max(dp[ni][nj], nk);
            }
        }

        dp[i][j] = --nk;
        if (nk >= 0) pq.emplace(i, j, nk);
        cnt++;
    }

    cout << cnt << endl;
    return 0;
}
