#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 128;

struct state
{
    int x, y, z, kom;
    state(){}
    state(int x, int y, int z,int kom)
    {
        this -> x = x;
        this -> y = y;
        this -> z = z;
        this -> kom = kom;
    }
};

bool operator<(state x, state y)
{
    if (x.z != y.z) return x.z < y.z;
    else return x.kom < y.kom;
}

int dir[8][2] = {{+1, -2}, {+1, +2}, {-1, -2}, {-1, +2}, {+2, -1}, {+2, +1}, {-2, -1}, {-2, +1}};

int n, m, k;
int a[MAXN][MAXN];

long long cnt = 0;
int dp[MAXN][MAXN];
priority_queue<state> pq;

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> k;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = 0; j < m; ++ j)
        {
            char ch;
            cin >> ch;
            if (ch == '.')
            {
                a[i][j] = 0;
            }
            else a[i][j] = 1;
        }
    }

    vector<pair<int, int>> shots;

    for (int i = 0; i < n; ++ i)
    {
        for (int j = 0; j < m; ++ j)
        {
            if (a[i][j]) continue;

            int is = 0;
            for (int d = 0; d < 8; ++ d)
            {
                int ni = i + dir[d][0];
                int nj = j + dir[d][1];

                if (ni >= 0 and nj >= 0 and ni < n and nj < m and a[ni][nj] == 0)
                {
                    is++;
                }
            }

            if (is == 0)
            {
                a[i][j] = 1;
                shots.emplace_back(i, j);
            }
            else
            {
                dp[i][j] = k;
                pq.emplace(i, j, k, is);
            }
        }
    }

    while (!pq.empty())
    {
        state t = pq.top();
        pq.pop();

        int i = t.x;
        int j = t.y;
        int nk = -3;

        shots.emplace_back(i, j);

        int kom = 0;
        for (int d = 0; d < 8; ++ d)
        {
            int ni = i + dir[d][0];
            int nj = j + dir[d][1];

            if (ni >= 0 and nj >= 0 and ni < n and nj < m and a[ni][nj] == 0)
            {
                nk = max(dp[ni][nj], nk);
                if (dp[ni][nj] != 0) kom++;
            }
        }

        dp[i][j] = --nk;
        if (nk >= 0) pq.emplace(i, j, nk, kom);
    }

    cout << shots.size() << endl;
    for (int i = 0; i < shots.size(); ++ i)
    {
        cout << shots[i].first << ' ' << shots[i].second << endl;
    }

    return 0;
}
