#pragma GCC optimize "Ofast"
#include <iostream>
#include "park.h"

const int MAX_N = 10000 + 20;
int known[MAX_N][MAX_N];

void set(int a, int b, int r) {
	known[a][b] =  r;
	known[b][a] = !r;
	state_direction({a, b}, r);
}

int __stat_saved = 0;
int __stat_missed = 0;

int gxor(const std::vector<std::pair<int, int>> &pairs) {
	bool any = false;
	for(auto p : pairs) {
		if(known[p.first][p.second] == -1) { any = true; }
	}

	if(!any) {
		__stat_saved ++;
		int ans = known[pairs[0].first][pairs[0].second];
		for(int i = 1;i < pairs.size();i ++) ans ^= known[pairs[i].first][pairs[i].second];
		return ans;
	}

	__stat_missed ++;

	return get_xor(pairs);
}

void run(int N) {
	for(int i = 1;i <= 2*N+2;i ++) {
		for(int j = 1;j <= 2*N+2;j ++) { known[i][j] = -1; }
	}

	state_direction({1, 2}, 1);
	state_direction({1, 3}, 1);
	state_direction({2*N+1, 2*N+2}, 1);
	state_direction({2*N+0, 2*N+2}, 1);

	known[1][2] = 1;
	known[2][1] = 0;

	known[1][3] = 1;
	known[3][1] = 0;

	known[2*N+1][2*N+2] = 1;
	known[2*N+2][2*N+1] = 0;

	known[2*N+0][2*N+2] = 1;
	known[2*N+2][2*N+0] = 0;

	for(int block = 1;block < N;block ++) {
		const int A = block*2 - 1;
		const int B = A+1;
		const int C = A+2;
		const int D = A+3;
		const int E = A+4;
		const int F = A+5;
		
		if(known[A][B] == 1 and known[A][C]) {
			const int ab = gxor({{B, C}, {C, D}});
			if(ab == 1) {
				const int a = gxor({{B, C}});
				if(a == 1) { // II
					set(B, C, 1);
					set(B, D, 0);
					set(C, D, 0);

					set(C, E, 1);
				}
				if(a == 0) { // III
					set(B, C, 0);
					set(B, D, 1);
					set(C, D, 1);
				}
			}
			if(ab == 0) { // I
				set(B, C, 1);
				set(B, D, 1);
				set(C, D, 1);

				const int z = gxor({{C, E}});
				set(C, E, z);
				continue;
				//goto endblock;
			}
		}

		//endblock:
		//end of for
	}

	set(2*N+0, 2*N+1, gxor({{2*N+0, 2*N+1}}));
}
