#include <cstdio>
#include <vector>

using namespace std;

const int MAXN = 1e2;
const int moveY[] = {-2, -2, +2, +2};
const int moveX[] = {-1, +1, -1, + 1};

int n, m, k;
bool a[MAXN][MAXN];
bool T[MAXN][MAXN][MAXN];

void read_input()
{
    scanf("%d %d %d", &n, &m, &k);

    for(int i = 0; i < n; i++)
    {
        char c;
        for(int j = 0; j < m; j++)
        {
            scanf(" %c", &c);
            if(c == '.')
            {
                a[i][j] = 1;
            }
            else
            {
                a[i][j] = 0;
            }
        }
    }

    /*for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            printf("%d ", a[i][j]);
        }
        printf("\n");
    }*/
}

void mark(int i, int j)
{
    for(int z = 0; z < 4; z++)
    {
        int nI = i + moveY[z];
        int nJ = j + moveX[z];

        if(nI < 0 || nI >= n || nJ < 0 || nJ >= m) continue;

        for(int g = 1; g <= k; g++)
        {
            T[nI][nJ][g] |= T[i][j][g - 1];
        }
    }
}

vector < pair<int,int> > v;

void solve_for(int fy, int fx)
{
    if(fy >= n) return;
    int y = fy, x = fx;
    vector < pair <int, int> > prev;
    for(int h = 0; h <= k; h++)
    {
        int cnt = 0;
        prev.clear();
        y = fy; x = fx;
        while(y < n)
        {
            if(!a[y][x])
            {
                x ^= 1;
                y += 2;
                continue;
            }
            for(int i = 0; i < cnt; i++)
            {
                mark(prev[i].first, prev[i].second);
            }
            for(int i = 0; i <= k; i++)
            {
                T[y][x][i] = 0;
            }
            prev.push_back({y, x});
            v.push_back({y, x});

            cnt++;
            x ^= 1;
            y += 2;
        }
    }
}

void solve()
{
    if(m == 2)
    {
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < m; j++)
            {
                if(a[i][j])
                T[i][j][0] = true;
            }
        }
        solve_for(0, 0);
        solve_for(0, 1);
        solve_for(1, 0);
        solve_for(1, 1);

        printf("%d\n", v.size());
        for(int i = 0; i < v.size(); i++)
        {
            printf("%d %d\n", v[i].first, v[i].second);
        }
    }
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
3 5 1
.....
#####
.#.#.
*/

/*
5 2 1
..
..
..
..
..
*/

/*
5 2 1
..
.#
..
#.
..
*/
