#include <cstdio>
#include <algorithm>

using namespace std;

typedef long long ll;

const int MAXN = 1e2 * 2;
const int INF = 1e9;

struct person
{
    ll a, b, s;

    ll get_cost()
    {
        return (a + (b * s));
    }
};

bool cmp(person f, person s)
{
    return f.get_cost() > s.get_cost();
}

ll n, l;
person a[MAXN];

void read_input()
{
    scanf("%lld %lld", &n, &l);

    for(int i = 0; i < n; i++)
    {
        scanf("%lld %lld", &a[i].a, &a[i].b);
    }
}

ll T[MAXN][MAXN];

void solve_for(int index)
{
    if(index == 1)
    {
        printf("%lld\n", a[0].a + (a[0].b * (l - 1)));
        return;
    }
    for(int i = 0; i < l; i++)
    {
        for(int j = 0; j < n; j++)
        {
            T[i][j] = -INF;
        }
    }
    for(int i = 0; i < l; i++)
    {
        T[i][0] = a[0].a + (a[0].b * i);
    }
    //T[0][0] = a[0].a;

    long long ans = 0;

    for(int i = 1; i < l; i++)
    {
        for(int j = 1; j < index; j++)
        {
            for(int z = 0; z < i; z++)
            {
                ll temp = T[z][j - 1] + a[j].a + ((a[j - 1].b + a[j].b) * (i - z - 1));
                if(j == index - 1)
                {
                    temp += (l - i - 1) * a[j].b;
                    ans = max(ans, temp);
                }
                T[i][j] = max(T[i][j], temp);
            }
        }
    }

    printf("%lld\n", ans);
}

void solve()
{
    for(int i = 1; i <= n; i++)
    {
        if(i > l)
        {
            printf("0\n");
            continue;
        }
        for(int j = 0; j < n; j++)
        {
            a[j].s = l - i;
        }
        sort(a, a + n, cmp);
        solve_for(i);
    }
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
3 2
1 2
3 4
5 6
*/

/*
3 3
1 2
3 4
5 100
*/
