#include <cstdio>
#include <algorithm>

using namespace std;

typedef long long ll;

const int MAXN = 1e2 * 2;
const int MAXL = 1e3;
const int INF = 1e9;

struct person
{
    ll a, b, s;

    ll get_cost()
    {
        return (a + (b * s));
    }
};

bool cmp(person f, person s)
{
    return f.get_cost() > s.get_cost();
}

ll n, l;
person a[MAXN];

void read_input()
{
    scanf("%lld %lld", &n, &l);

    for(int i = 0; i < n; i++)
    {
        scanf("%lld %lld", &a[i].a, &a[i].b);
    }
}

ll T[MAXL][MAXN][MAXL];

void solve_for(int index)
{
    if(index == 1)
    {
        printf("%lld\n", a[0].a + (a[0].b * (l - 1)));
        return;
    }
    for(int i = 0; i < l; i++)
    {
        for(int j = 0; j < n; j++)
        {
            for(int z = 0; z < l; z++)
            T[i][j][z] = -INF;
        }
    }
    for(int i = 0; i < l; i++)
    {
        T[0][0][l - i - 1] = a[0].a + a[0].b * (l - i - 1);
    }

    long long ans = 0;

    for(int i = 1; i < l; i++)
    {
        for(int j = 1; j < index; j++)
        {
            for(int z = 0; z < i; z++)
            {
                for(int g = l - i - 1; g >= 0; g--)
                {
                    ll temp = T[z][j - 1][i - z - 1] + a[j].a + (a[j].b * (i - z - 1)) + (a[j].b * g);
                    T[i][j][g] = max(T[i][j][g], temp);
                }
            }
        }
    }

    printf("%lld\n", T[l - 1][index - 1][0]);
}

void solve()
{
    for(int i = 1; i <= n; i++)
    {
        if(i > l)
        {
            printf("0\n");
            continue;
        }
        for(int j = 0; j < n; j++)
        {
            a[j].s = l - i;
        }
        sort(a, a + n, cmp);
        solve_for(i);
    }
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
3 2
1 2
3 4
5 6
*/

/*
3 3
1 2
3 4
5 100
*/
