#include <cstdio>
#include <algorithm>

using namespace std;

typedef long long ll;

const int MAXN = 1e2 * 2;
const int MAXL = 1e3;
const int INF = 1e9;

ll n, l;

struct person
{
    ll a, b;

    ll get_cost(int s)
    {
        return (a + (b * s));
    }
};

bool cmp(person f, person s)
{
    return f.get_cost(l - 1) > s.get_cost(l - 1);
}
person a[MAXN];


void read_input()
{
    scanf("%lld %lld", &n, &l);

    for(int i = 0; i < n; i++)
    {
        scanf("%lld %lld", &a[i].a, &a[i].b);
    }
}

ll T[MAXL];

ll get_sum()
{
    ll ans = 0;

    int cnt = 0, prev = 0;

    for(int i = 0; i < l; i++)
    {
        if(T[i] == -1)
        {
            cnt++;
        }
        else
        {
            ans += cnt * (a[T[i]].b + prev) + a[T[i]].a;
            prev = a[T[i]].b;
            cnt = 0;
        }
    }
    ans += cnt * prev;
    return ans;
}

void solve_for(int index)
{
    if(index == 1)
    {
        T[0] = 0;
        printf("%lld\n", get_sum());
        return;
    }
    else
    {
        ll ans = 0;
        int bst;
        for(int i = 0; i < l; i++)
        {
            if(T[i] == -1)
            {
                T[i] = index - 1;
                ll temp = get_sum();
                if(ans < temp)
                {
                    ans = temp;
                    bst = i;
                }
                T[i] = -1;
            }
        }
        T[bst] = index - 1;
        printf("%lld\n", ans);
    }
}

void solve()
{
    for(int i = 0; i < l; i++)
    {
        T[i] = -1;
    }
    sort(a, a + n, cmp);
    for(int i = 1; i <= n; i++)
    {
        if(i > l)
        {
            printf("0\n");
            continue;
        }
        solve_for(i);
    }
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
3 2
1 2
3 4
5 6
*/

/*
3 3
1 2
3 4
5 100
*/
