#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

const int MAXN = 1e5 + 5;
const double inf = 1e15 + 5;

struct line
{
    double a, b;
    int index;
};

double cross(line A, line B)
{
    if(A.a==B.a) return inf;
    return (B.b-A.b)/(A.a-B.a);
}

bool operator <(const line A, const line B)
{
    if(A.a!=B.a) return A.a<B.a;
    return A.b>B.b;
}

int n;
long long L;
pair <long long, long long> a[MAXN];

vector <line> l, v;

int bestLine(double x)
{
    if(cross(v[ v.size() - 1 ], v[ v.size() - 2 ]) <= x)
    {
        return v[ v.size() - 1 ].index;
    }

    int l = 0, r = v.size() - 2, mid;

    while(l+1<r)
    {
        mid = (l+r)/2;

        if(cross(v[mid], v[mid+1]) >= x) r = mid;
        else l = mid + 1;
    }

    if(cross(v[l], v[l+1]) >= x) return v[l].index;
    return v[r].index;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int index, found, index1;
    long long last = 0, toAdd;

    cin >> n >> L;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i].first >> a[i].second;
    }

    sort(a, a+n);
    for(int i = 0;i<n;i++)
    {
        l.push_back({a[i].second, a[i].first, i});
    }
    sort(l.begin(), l.end());

    v.push_back(l[0]);
    v.push_back(l[1]);
    for(int i = 2;i<n;i++)
    {
        while(v.size()>=2 && cross(v[ v.size() - 1 ], v[ v.size() - 2 ])>=cross(v[ v.size() - 2 ], l[i]))
        {
            v.pop_back();
        }

        v.push_back(l[i]);
    }

    for(int i = 1;i<=n;i++)
    {
        if(i>L)
        {
            cout << "0" << '\n';
            continue;
        }

        index = bestLine(L-i);
        last = a[index].first + (L-i)*a[index].second;

        index1 = -1;
        if(i>=2)
        {
            toAdd = 0;
            index1 = 0;
            for(int j = 0;j<n;j++)
            {
                if(j==index) continue;
                if(toAdd < a[j].first + (L-i)*a[j].second)
                {
                    toAdd = a[j].first + (L-i)*a[j].second;
                    index1 = j;
                }
            }

            last += toAdd;
        }

        found = 2;
        for(int j = n-1;j>=0;j--)
        {
            if(found>=i) break;
            if(j==index) continue;
            if(j==index1) continue;

            found++;
            last += a[j].first;
            //cout << " += " << a[index].first << " " << j << '\n';
        }

        cout << last << '\n';
    }
}
