#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

const int MAXN = 1e5 + 5;
const double inf = 1e15 + 5;

struct line
{
    double a, b;
    int index;
};

double cross(line A, line B)
{
    if(A.a==B.a) return inf;
    return (B.b-A.b)/(A.a-B.a);
}

bool operator <(const line A, const line B)
{
    if(A.a!=B.a) return A.a<B.a;
    return A.b>B.b;
}

int n;
long long L;
pair <long long, long long> a[MAXN];

vector <line> l, v;

int bestLine(double x)
{
    if(cross(v[ v.size() - 1 ], v[ v.size() - 2 ]) <= x)
    {
        return v[ v.size() - 1 ].index;
    }

    int l = 0, r = v.size() - 2, mid;

    while(l+1<r)
    {
        mid = (l+r)/2;

        if(cross(v[mid], v[mid+1]) >= x) r = mid;
        else l = mid + 1;
    }

    if(cross(v[l], v[l+1]) >= x) return v[l].index;
    return v[r].index;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int index, found, index1;
    long long option1 = 0, toAdd, option2, answer;

    cin >> n >> L;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i].first >> a[i].second;
    }

    if(n==1)
    {
        cout << (L-1)*a[0].second + a[0].first << '\n';
        return 0;
    }

    sort(a, a+n);

    /*
    for(int i = 0;i<n;i++)
    {
        l.push_back({a[i].second, a[i].first, i});
    }
    sort(l.begin(), l.end());

    v.push_back(l[0]);
    v.push_back(l[1]);
    for(int i = 2;i<n;i++)
    {
        while(v.size()>=2 && cross(v[ v.size() - 1 ], v[ v.size() - 2 ])>=cross(v[ v.size() - 2 ], l[i]))
        {
            v.pop_back();
        }

        v.push_back(l[i]);
    }
    */

    for(int i = 1;i<=n;i++)
    {
        if(i>L)
        {
            cout << "0" << '\n';
            continue;
        }

        //index = bestLine(L-i);
        //last = a[index].first + (L-i)*a[index].second;

        if(i==1)
        {
            answer = 0;
            for(index = 0;index<n;index++)
            {
                option1 = (L-i)*a[index].second + a[index].first;

                found = 1;
                for(int j = n-1;j>=0;j--)
                {
                    if(found>=i) break;
                    if(j==index)
                    {
                        continue;
                    }

                    found++;
                    option1 += a[j].first;
                }

                answer = max(answer, option1);
            }

            cout << answer << '\n';
        }
        else
        {
            answer = 0;
            for(index = 0;index<n;index++)
            {
                for(index1 = index+1;index1<min(n, index+2);index1++)
                {
                    option1 = (L-i)*a[index].second + a[index].first;
                    option1 += (L-i)*a[index1].second + a[index1].first;

                    found = 2;
                    for(int j = n-1;j>=0;j--)
                    {
                        if(found>=i) break;
                        if(j==index || j==index1)
                        {
                            continue;
                        }

                        found++;
                        option1 += a[j].first;
                    }

                    answer = max(answer, option1);
                }
            }

            cout << answer << '\n';
        }
    }
}
