#include<iostream>
#include<vector>
#include<random>
#include<algorithm>

using namespace std;

const int MAXN = 1e5 + 5;
const double inf = 1e15 + 5;

mt19937 randomGenerator(69420);

struct line
{
    double a, b;
    int index;
};

struct st
{
    long long first, second;
    int index;
};

double cross(line A, line B)
{
    if(A.a==B.a) return inf;
    return (B.b-A.b)/(A.a-B.a);
}

bool operator <(const line A, const line B)
{
    if(A.a!=B.a) return A.a<B.a;
    return A.b>B.b;
}

bool cmp1(const st A, const st B)
{
    if(A.first!=B.first) return A.first<B.first;
    if(A.second!=B.second) return A.second<B.second;
    return A.index < B.index;
}

bool cmp2(const st A, const st B)
{
    if(A.second!=B.second) return A.second<B.second;
    if(A.first!=B.first) return A.first<B.first;

    return A.index < B.index;
}

int n;
long long L;
st a[MAXN], aCopy[MAXN];

vector <line> l, v;

long long tree[MAXN*4];

void build(int l, int r, int index)
{
    if(l==r)
    {
        tree[index] = a[l].first;
        return;
    }

    build(l, (l+r)/2, 2*index);
    build((l+r)/2+1, r, 2*index+1);
    tree[index] = tree[2*index] + tree[2*index+1];
}

long long query(int l, int r, int ql, int qr, int index)
{
    if(ql>qr) return 0;

    if(l>=ql && r<=qr) return tree[index];
    if(r<ql || l>qr) return 0;

    return query(l, (l+r)/2, ql, qr, 2*index) + query((l+r)/2+1, r, ql, qr, 2*index+1);
}

void update(int l, int r, int q, int index, long long value)
{
    if(l==r && l==q)
    {
        tree[q] = value;
        return;
    }
    if(r<q || l>q) return;

    update(l, (l+r)/2, q, 2*index, value);
    update((l+r)/2+1, r, q, 2*index+1, value);

    tree[index] = tree[2*index] + tree[2*index+1];
}

int bestLine(double x)
{
    if(cross(v[ v.size() - 1 ], v[ v.size() - 2 ]) <= x)
    {
        return v[ v.size() - 1 ].index;
    }

    int l = 0, r = v.size() - 2, mid;

    while(l+1<r)
    {
        mid = (l+r)/2;

        if(cross(v[mid], v[mid+1]) >= x) r = mid;
        else l = mid + 1;
    }

    if(cross(v[l], v[l+1]) >= x) return v[l].index;
    return v[r].index;
}

int index2Index[MAXN];
long long answer = 0;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int minus1, minus2;

    int last = 0;
    int index, found, index1;
    long long option1 = 0, toAdd, option2;

    int help1, help2;

    cin >> n >> L;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i].first >> a[i].second;
        a[i].index = i;

        aCopy[i] = a[i];
    }

    minus1 = 0;
    minus2 = 5000;
    if(n>=200)
    {
        minus1 = 5;
        minus2 = 5;
    }

    sort(a, a+n, cmp1);
    sort(aCopy, aCopy+n, cmp2);

    for(int i = 0;i<n;i++)
    {
        index2Index[ aCopy[i].index ] = i;
    }

    build(0, n-1, 1);

    if(n==1)
    {
        cout << (L-1)*a[0].second + a[0].first << '\n';
        return 0;
    }

    for(int i = 1;i<=n;i++)
    {
        if(i>L)
        {
            cout << "0" << '\n';
            continue;
        }

        //index = bestLine(L-i);
        //last = a[index].first + (L-i)*a[index].second;

        if(i==1)
        {
            answer = 0;
            for(index = 0;index<n;index++)
            {
                option1 = (L-i)*a[index].second + a[index].first;

                found = 1;
                for(int j = n-1;j>=0;j--)
                {
                    if(found>=i) break;
                    if(j==index)
                    {
                        continue;
                    }

                    found++;
                    option1 += a[j].first;
                }

                answer = max(answer, option1);
            }

            cout << answer << '\n';
        }
        else
        {
            answer = 0;
            for(index = max(0, last-minus1);index<((i!=2)?last+minus2:n);index++)
            {
                for(index1 = index+1;index1<n;index1++)
                {
                    option1 = (L-i)*aCopy[index].second + aCopy[index].first;
                    option1 += (L-i)*aCopy[index1].second + aCopy[index1].first;

                    found = 2;
                    for(int j = n-1;j>=0;j--)
                    {
                        if(found>=i) break;
                        if(a[j].index==aCopy[index].index || a[j].index==aCopy[index1].index)
                        {
                            continue;
                        }

                        found++;
                        option1 += a[j].first;
                    }

                    /*
                    update(0, n-1, index2Index[ aCopy[index].index ], 1, 0);
                    update(0, n-1, index2Index[ aCopy[index1].index ], 1, 0);

                    if(index2Index[ aCopy[index].index ] < n - i + 2)
                    {
                        if(index2Index[ aCopy[index1].index ] < n - i + 2)
                            option1 += query(0, n-1, n-i+2, n-1, 1);
                        else
                            option1 += query(0, n-1, n-i+2-1, n-1, 1);
                    }
                    else
                    {
                        //if(i==2) cout << "  " << query(0, n-1, n-i+2-2, n-1, 1) << '\n';

                        option1 += query(0, n-1, n-i+2-2, n-1, 1);
                    }

                    update(0, n-1, index2Index[ aCopy[index].index ], 1, a[ index2Index[ aCopy[index].index ] ].first);
                    update(0, n-1, index2Index[ aCopy[index1].index ], 1, a[ index2Index[ aCopy[index1].index ] ].first);
                    */

                    if(option1>answer)
                    {
                        answer = option1;
                        last = index;
                    }
                }
            }

            cout << answer << '\n';
        }
    }
}
/*
9 1000
100 50
7 8
2 3
2 300
80 5
3 4
1 1000
9 6
6 9
*/
