#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll INF = 1e18;
const int MAXN = (int) 1e5;

struct Data {
    int a, b;
    bool operator <(const Data &other) const {
        return a > other.a;
    }
}arr[MAXN + 1];

int pref[MAXN + 1][2];
ll sp[MAXN + 1], sol[MAXN + 1];

struct Line {
    ll a, b;
    bool operator <(const Line &other) const {
        if(a == other.a) {
            return b >= other.b;
        }
        return a < other.a;
    }
}lines[MAXN + 1];

inline double inter(Line l1, Line l2) {
    if(l1.a == l2.a) {
        return 1.0 * INF;
    }
    return 1.0 * (l2.b - l1.b) / (l1.a - l2.a);
}

inline ll get(Line l, int x) {
    return 1LL * l.a * x + l.b;
}

vector <int> aint1[4 * MAXN + 1], aint2[4 * MAXN + 1];
int stk[MAXN + 1];

inline void refresh1(int nod) {
    int i = 0, j = 0;
    int sz1 = aint1[2 * nod].size(), sz2 = aint1[2 * nod + 1].size();
    while(i < sz1 && j < sz2) {
        if(lines[aint1[2 * nod][i]] < lines[aint1[2 * nod + 1][j]]) {
            aint1[nod].push_back(aint1[2 * nod][i]);
            i++;
        }
        else {
            aint1[nod].push_back(aint1[2 * nod + 1][j]);
            j++;
        }
    }
    while(i < sz1) {
        aint1[nod].push_back(aint1[2 * nod][i]);
        i++;
    }
    while(j < sz2) {
        aint1[nod].push_back(aint1[2 * nod + 1][j]);
        j++;
    }
}

inline void refresh2(int nod) {
    int i = 0, j = 0, k = 0;
    int sz1 = aint2[2 * nod].size(), sz2 = aint2[2 * nod + 1].size(), sz3 = aint2[nod].size();
    vector <int> aux;
    while(i < sz1 || j < sz2 || k < sz3) {
        Line l1, l2, l3;
        if(i < sz1)
            l1 = lines[aint2[2 * nod][i]];
        else
            l1 = {INF, INF};
        if(j < sz2)
            l2 = lines[aint2[2 * nod + 1][j]];
        else
            l2 = {INF, INF};
        if(k < sz3)
            l3 = lines[aint2[nod][k]];
        else
            l3 = {INF, INF};
        if(l1 < l2 && l1 < l3) {
            aux.push_back(aint2[2 * nod][i]);
            i++;
        }
        else if(l2 < l3 && l2 < l1) {
            aux.push_back(aint2[2 * nod + 1][j]);
            j++;
        }
        else {
            aux.push_back(aint2[nod][k]);
            k++;
        }
    }
    swap(aux, aint2[nod]);
}

inline void batch2(int nod) {
    refresh2(nod);
    int sz = 0;
    for(auto it : aint2[nod]) {
        while(sz > 1 && inter(lines[stk[sz - 1]], lines[it]) - inter(lines[stk[sz - 1]], lines[stk[sz]]) < 0) {
            sz--;
        }
        stk[++sz] = it;
    }
    aint2[nod].resize(sz);
    for(int i = 1; i <= sz; i++) {
        aint2[nod][i - 1] = stk[i];
    }
}

inline void batch1(int nod) {
    refresh1(nod);
    int sz = 0;
    for(auto it : aint1[nod]) {
        while(sz > 1 && inter(lines[stk[sz - 1]], lines[it]) - inter(lines[stk[sz - 1]], lines[stk[sz]]) < 0) {
            aint2[nod].push_back(stk[sz]);
            sz--;
        }
        stk[++sz] = it;
    }
    aint1[nod].resize(sz);
    for(int i = 1; i <= sz; i++) {
        aint1[nod][i - 1] = stk[i];
    }
    batch2(nod);
}

void build(int nod, int left, int right) {
    if(left == right) {
        aint1[nod].push_back(left);
    }
    else {
        int mid = (left + right) / 2;
        build(2 * nod, left, mid);
        build(2 * nod + 1, mid + 1, right);
        batch1(nod);
    }
}

char lg[MAXN + 1];
ll mx1, mx2;

void query(int nod, int left, int right, int l, int r, int x) {
    if(l <= left && right <= r) {
        int res = -1, sz = aint1[nod].size();
        for(int step = 1 << 17; step; step >>= 1) {
            if(res + step < sz - 1 && get(lines[aint1[nod][res + step]], x) <= get(lines[aint1[nod][res + step + 1]], x)) {
                res += step;
            }
        }
        res++;
        ll cur1 = get(lines[aint1[nod][res]], x);
        ll cur2 = 0;
        if(res < sz - 1) {
            cur2 = max(cur2, get(lines[aint1[nod][res + 1]], x));
        }
        if(res > 0) {
            cur2 = max(cur2, get(lines[aint1[nod][res - 1]], x));
        }
        res = -1;
        sz = aint2[nod].size();
        for(int step = 1 << 17; step; step >>= 1) {
            if(res + step < sz - 1 && get(lines[aint2[nod][res + step]], x) <= get(lines[aint2[nod][res + step + 1]], x)) {
                res += step;
            }
        }
        res++;
        if(res < sz) {
            cur2 = max(cur2, get(lines[aint2[nod][res]], x));
        }
        if(res + 1 < sz) {
            cur2 = max(cur2, get(lines[aint2[nod][res + 1]], x));
        }
        if(res > 0) {
            cur2 = max(cur2, get(lines[aint2[nod][res - 1]], x));
        }
        if(cur2 > cur1) {
            while(1) {

            }
        }
        if(cur1 >= mx1) {
            mx2 = max(mx1, cur2);
            mx1 = cur1;
        }
        else if(cur1 >= mx2) {
            mx2 = cur1;
        }
    }
    else {
        int mid = (left + right) / 2;
        if(l <= mid)
            query(2 * nod, left, mid, l, r, x);
        if(mid < r)
            query(2 * nod + 1, mid + 1, right, l, r, x);
    }
}

int main() {
    FILE *fi, *fout;
    int i, n, l;
    //fi = fopen("B.in" ,"r");
    //fout = fopen("B.out" ,"w");
    fi = stdin;
    fout = stdout;
    fscanf(fi,"%d %d " ,&n,&l);
    for(i = 1; i <= n; i++) {
        fscanf(fi,"%d %d " ,&arr[i].a,&arr[i].b);
    }
    sort(arr + 1, arr + n + 1);
    int b1 = 0, b2 = 0;
    for(i = 1; i <= n; i++) {
        sp[i] = sp[i - 1] + arr[i].a;
        lines[i] = {arr[i].b, arr[i].a};
        if(arr[i].b >= b1) {
            b2 = b1;
            b1 = arr[i].b;
        }
        else if(arr[i].b >= b2) {
            b2 = arr[i].b;
        }
        pref[i][0] = b1;
        pref[i][1] = b2;
    }
    build(1, 1, n);
    for(int k = 1; k <= min(n, l); k++) {
        ll ans = 0;
        if(k == 1) {
            for(i = 1; i <= n; i++) {
                ans = max(ans, arr[i].a + 1LL * arr[i].b * (l - 1));
            }
        }
        else {
            mx1 = mx2 = 0;
            query(1, 1, n, k - 1, n, (l - k));
            ans = max(ans, sp[k - 2] + mx1 + mx2);
            mx1 = mx2 = 0;
            query(1, 1, n, k, n, (l - k));
            ans = max(ans, 1LL * pref[k - 1][0] * (l - k) + sp[k - 1] + mx1);
            ans = max(ans, 1LL * (pref[k][0] + pref[k][1]) * (l - k) + sp[k]);
        }
        sol[k] = ans;
    }
    for(i = 1; i <= n; i++) {
        fprintf(fout,"%lld\n" ,sol[i]);
    }
    //fclose(fi);
    //fclose(fout);
    return 0;
}
