#include <bits/stdc++.h>
using namespace std;

const int DIM = 200005;
const long double EPS = 1e-6;

long long psm[DIM], sol[DIM];
pair<int, int> arr[DIM], mxm[DIM];

struct Line {
    long double a, b; int pos;
    Line() : a(0), b(0), pos(0) {}
    Line(long double _a, long double _b, int _pos) :
        a(_a), b(_b), pos(_pos) {};
}; vector<Line> sgt[DIM * 4];

long double intersect(Line d1, Line d2) {
    return (d2.b - d1.b) / (d1.a - d2.a); }

int sign(long double x, long double y) {
    if (-EPS < x - y && x - y < EPS) {
        return 0; }
    return x - y < 0 ? -1 : 1; }

inline bool cmp(const Line &l1, const Line &l2) {
    if (!sign(l1.a, l2.a)) {
        return sign(l1.a, l2.a) < 0; }
    return sign(l1.b, l2.b) < 0; }

void buildCH(vector<Line> &lis) {
    sort(lis.begin(), lis.end(), cmp);
    int sz = 0;
    for (int i = 1; i < lis.size(); ++i) {
        if (lis[sz].a == lis[i].a) {
            lis[sz] = lis[i]; continue; }
        while (sz && sign(intersect(lis[sz], lis[i]),
                          intersect(lis[sz - 1], lis[sz])) <= 0) {
            --sz; }
        lis[++sz] = lis[i]; } }

int findLine(vector<Line> &lis, int pos) {
    int st = 0, en = lis.size() - 2;
    while (st <= en) {
        int md = (st + en) / 2;
        if (sign(lis[md].a * pos + lis[md].b,
                 lis[md + 1].a * pos + lis[md + 1].b) < 0) {
            st = md + 1; }
        else {
            en = md - 1; } }
    return lis[st].pos; }

void build(int nd, int le, int ri) {
    if (le != ri) {
        int md = (le + ri) / 2;
        build(nd * 2, le, md);
        build(nd * 2 + 1, md + 1, ri); }
    for (int i = le; i <= ri; ++i) {
        sgt[nd].push_back(Line(arr[i].second, arr[i].first, i)); }
    buildCH(sgt[nd]); }

int query(int nd, int le, int ri, int st, int en, int pos) {
    if (st <= le && ri <= en) {
        return findLine(sgt[nd], pos); }
    else {
        int md = (le + ri) / 2;
        if (en <= md) {
            return query(nd * 2, le, md, st, en, pos); }
        if (md < st) {
            return query(nd * 2 + 1, md + 1, ri, st, en, pos); }
        int l1 = query(nd * 2, le, md, st, en, pos),
            l2 = query(nd * 2 + 1, md + 1, ri, st, en, pos);
        if (1LL * arr[l1].second * pos + arr[l1].first >
            1LL * arr[l2].second * pos + arr[l2].first) {
            return l1; }
        else {
            return l2; } } }

void bruteForce(int n, int l) {
    for (int k = 1; k <= min(n, l); ++k) {
        if (k == 1) {
            for (int i = 1; i <= n; ++i) {
                sol[k] = max(sol[k], 1LL * (l - k) * arr[i].second + arr[i].first); } }
        else {
            long long mx1, mx2;
            //k
            mx1 = mx2 = 0;
            for (int i = 1; i <= k; ++i) {
                if (mx1 < arr[i].second) {
                    mx2 = mx1; mx1 = arr[i].second; }
                else if (mx2 < arr[i].second) {
                    mx2 = arr[i].second; } }
            sol[k] = max(sol[k], 1LL * (l - k) * (mx1 + mx2) + psm[k]);
            //k - 1;
            mx1 = mx2 = 0;
            for (int i = 1; i < k; ++i) {
                if (mx1 < arr[i].second) {
                    mx1 = arr[i].second; } }
            for (int i = k; i <= n; ++i) {
                if (mx2 < 1LL * (l - k) * arr[i].second + arr[i].first) {
                    mx2 = 1LL * (l - k) * arr[i].second + arr[i].first; } }
            sol[k] = max(sol[k], 1LL * (l - k) * mx1 + mx2 + psm[k - 1]);
            //k - 2;
            mx1 = mx2 = 0;
            for (int i = k - 1; i <= n; ++i) {
                if (mx1 < 1LL * (l - k) * arr[i].second + arr[i].first) {
                    mx2 = mx1; mx1 = 1LL * (l - k) * arr[i].second + arr[i].first; }
                else if (mx2 < 1LL * (l - k) * arr[i].second + arr[i].first) {
                    mx2 = 1LL * (l - k) * arr[i].second + arr[i].first; } }
            sol[k] = max(sol[k], mx1 + mx2 + psm[k - 2]); } } }

void optimum(int n, int l) {
    for (int i = 1; i <= n; ++i) {
        mxm[i] = mxm[i - 1];
        if (mxm[i].first < arr[i].second) {
            mxm[i].second = mxm[i].first; mxm[i].first = arr[i].second; }
        else if (mxm[i].second < arr[i].second) {
            mxm[i].second = arr[i].second; } }
    for (int k = 1; k <= min(n, l); ++k) {
        if (k == 1) {
            for (int i = 1; i <= n; ++i) {
                sol[k] = max(sol[k], 1LL * (l - k) * arr[i].second + arr[i].first); } }
        else {
            long long mx1, mx2; int l1, l2;
            //k
            mx1 = mxm[k].first, mx2 = mxm[k].second;
            sol[k] = max(sol[k], 1LL * (l - k) * (mx1 + mx2) + psm[k]);
            //k - 1
            l1 = query(1, 1, n, k, n, l - k);
            sol[k] = max(sol[k], 1LL * (l - k) * (mx1 + arr[l1].second) + arr[l1].first + psm[k - 1]);
            // k - 2;
            l1 = query(1, 1, n, k - 1, n, l - k);
            if (l1 == k - 1) {
                l2 = query(1, 1, n, k, n, l - k); }
            else if (l2 == n) {
                l2 = query(1, 1, n, k - 1, n - 1, l - k); }
            else {
                int ax1 = query(1, 1, n, k - 1, l1 - 1, l - k),
                    ax2 = query(1, 1, n, l1 + 1, n, l - k);
                if (1LL * arr[ax1].second * (l - k) + arr[ax1].first >
                    1LL * arr[ax2].second * (l - k) + arr[ax2].first) {
                    l2 = ax1; }
                else {
                    l2 = ax2; } }
            sol[k] = max(sol[k], 1LL * (l - k) * (arr[l1].second + arr[l2].second) + arr[l1].first + arr[l2].first + psm[k - 2]); } } }

int main(void) {
  //  freopen("seats.in", "r", stdin);
  //  freopen("seats.out", "w", stdout);
    int n, l; cin >> n >> l;
    for (int i = 1; i <= n; ++i) {
        cin >> arr[i].first >> arr[i].second; }
    sort(arr + 1, arr + n + 1, greater<pair<int, int> >());
    for (int i = 1; i <= n; ++i) {
        psm[i] = psm[i - 1] + arr[i].first; }
    build(1, 1, n);
    bruteForce(n, l);
    //optimum(n, l);
    for (int i = 1; i <= n; ++i) {
        cout << sol[i] << "\n"; }
    return 0; }
