#include <bits/stdc++.h>
using namespace std;

const int DIM = 105;
const int dx[8] = {-2, -2, -1, 1, 2,  2, 1, -1};
const int dy[8] = {-1,  1,  2, 2, 1, -1, -2, -2};

string str[DIM]; vector<int> edg[DIM * DIM], teg[DIM * DIM];
int lef[DIM * DIM], rig[DIM * DIM];
bool mtl[DIM * DIM], mtr[DIM * DIM], mrk[DIM * DIM];
bitset<DIM * DIM> oki; vector<int> row[2], aux[2];
vector<pair<int, int> > sol;

void dfs(int x, int m) {
    row[(x / m + x % m) % 2].push_back(x);
    oki[x] = true;
    for (int y : edg[x]) {
        if (!oki[y]) { dfs(y, m); } } }

bool match(int x) {
    if (mrk[x]) {
        return false; }
    mrk[x] = true;
    for (int y : teg[x]) {
        if (!rig[y]) {
            lef[x] = y; rig[y] = x; return true; } }
    for (int y : teg[x]) {
        if (match(rig[y])) {
            lef[x] = y; rig[y] = x; return true; } }
    return false; }

void cover(int x) {
    for (int y : teg[x]) {
        if (!mtr[y]) {
            mtr[y] = true; mtl[rig[y]] = false;
            match(rig[y]); } } }

int main(void) {
   // freopen("chess.in", "r", stdin);
   // freopen("chess.out", "w", stdout);
    int n, m, k; cin >> n >> m >> k; k ++;
    for (int i = 0; i < n; ++i) {
        cin >> str[i]; }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (str[i][j] == '.') {
                bool ok = false;
                for (int d = 0; d < 8; ++d) {
                    int xx = i + dx[d], yy = j + dy[d];
                    if (xx >= 0 && xx < n && yy >= 0 && yy < m && str[xx][yy] == '.') {
                        ok = true; edg[i * m + j].push_back(xx * m + yy); } }
                if (!ok) {
                    sol.push_back(make_pair(i, j));
                    str[i][j] = '#'; } } } }
    for (int p = 0; p < n * m; ++p) {
        int x = p / m, y = p % m;
        if (oki[p] || str[x][y] == '#') { continue; }
        row[0].clear(); row[1].clear(); dfs(p, m);
        sort(row[0].begin(), row[0].end());
        sort(row[1].begin(), row[1].end());
        for (int i = 0; i < row[0].size(); ++i) {
            teg[i + 1].clear();
            for (int x : edg[row[0][i]]) {
                int j = lower_bound(row[1].begin(), row[1].end(), x) - row[1].begin();
                teg[i + 1].push_back(j + 1); } }
        for (int i = 1; i <= max(row[0].size(), row[1].size()); ++i) {
            lef[i] = rig[i] = 0; mtl[i] = mtr[i] = false; }
        bool ok; do {
            ok = false;
            for (int i = 1; i <= row[0].size(); ++i)
                mrk[i] = false;
            for (int i = 1; i <= row[0].size(); ++i) {
                if (!lef[i] && match(i)) {
                    ok = true; } }
        } while (ok);
        for (int i = 1; i <= row[1].size(); ++i) {
            mtr[i] = false; }
        for (int i = 1; i <= row[0].size(); ++i) {
            mtl[i] = lef[i] > 0; }
        for (int i = 1; i <= row[0].size(); ++i) {
            if (!mtl[i]) { cover(i); } }
        aux[0].clear(); aux[1].clear();
        for (int i = 1; i <= row[0].size(); ++i) {
            aux[1 - mtl[i]].push_back(row[0][i - 1]); }
        for (int i = 1; i <= row[1].size(); ++i) {
            aux[1 - mtr[i]].push_back(row[1][i - 1]); }
        for (int i = 0; i <= k; ++i) {
            for (int p : aux[i % 2]) {
                sol.push_back(make_pair(p / m, p % m)); } } }
    cout << sol.size() << "\n";
    for (auto pr : sol) {
        cout << pr.first << " " << pr.second << "\n"; }
    return 0; }



