#include <bits/stdc++.h>
#define mid ((st+dr)>>1)
#define left_son (node<<1)
#define right_son ((node<<1)|1)

using namespace std;

typedef pair<int,int> Pair;
typedef long long ll;
const int Nmax = 2e5 + 5;

int n, L;
ll Sum;
bool used[Nmax];
pair<int,int> b[Nmax];

struct ec
{
    int x, y;
    bool operator < (const ec &other) const
    {
        if(x == other.x) return y > other.y;
        return x < other.x;
    }

    ll get_val(int K) { return (ll) K * x + y; }
};
ec a[Nmax];

bool wrong(ec A, ec B, ec C)
{
    return (ll) (B.y - A.y) * (A.x - C.x) <= (C.y - A.y) * (A.x - B.x);
}

struct batch
{
    vector< pair<ec, int> > v;
    void insert(pair<ec, int> A)
    {
        ec now = A.first;
        if(v.size() && v.back().first.x == now.x) return;
        while(v.size() >= 2 && wrong(v[v.size()-2].first, v.back().first, now)) v.pop_back();
        v.push_back(A);
    }

    pair<ll, int> query(int K)
    {
        while(v.size() >= 2 && v.back().first.get_val(K) < v[v.size()-2].first.get_val(K))
            v.pop_back();
        ll K1; int K2;
        K1 = v.back().first.get_val(K);
        K2 = v.back().second;
        return make_pair(K1, K2);
    }
};


class Segtree
{
    batch a[Nmax<<2];
public:

    void add(int node, int st, int dr, int pos, ec A)
    {
        a[node].insert({A, pos});
        if(st == dr) return;

        if(pos <= mid) add(left_son, st, mid, pos, A);
            else add(right_son, mid+1, dr, pos, A);
    }

    pair<ll,int> query(int node, int st, int dr, int L, int R, int K)
    {
        if(L <= st && dr <= R) return a[node].query(K);

        pair<ll, int> P1, P2;
        P1 = P2 = {-1e18, 0};

        if(L <= mid) P1 = query(left_son, st, mid, L, R, K);
        if(mid < R) P2 = query(right_son, mid+1, dr, L, R, K);
        return max(P1, P2);
    }

} aint;

int main()
{
 //   freopen("input", "r", stdin);
 //   freopen("output", "w", stdout);
    cin.sync_with_stdio(false);

    int i;
    cin >> n >> L;
    for(i=1; i<=n; ++i) cin >> a[i].y >> a[i].x;
    sort(a+1, a+n+1);

    for(i=1; i<=n; ++i)
    {
        aint.add(1, 1, n, i, a[i]);
        b[i] = {a[i].y, i};
    }

    sort(b+1, b+n+1);
    reverse(b+1, b+n+1);

    cout << aint.query(1, 1, n, 1, n, L-1).first << '\n';

    for(i=2; i<=n && i<=L; ++i)
    {
        auto ans1 = aint.query(1, 1, n, 1, n, L-i);
        auto ans2 = max(aint.query(1, 1, n, 1, ans1.second-1, L-i), aint.query(1, 1, n, ans1.second+1, n, L-i));

        ll Ans = ans1.first + ans2.first;

        int x = ans1.second, y = ans2.second;

        if(used[x] && used[y])
            Ans += Sum - a[x].y - a[y].y + b[i-1].first + b[i].first;
        else if(used[x])
        {
            if(b[i-1].second == y)
                Ans += Sum - a[x].y + b[i].first;
            else Ans += Sum - a[x].y + b[i-1].first;
        }
        else if(used[y])
        {
            swap(x, y);
            if(b[i-1].second == y)
                Ans += Sum - a[x].y + b[i].first;
            else Ans += Sum - a[x].y + b[i-1].first;
        }
        else Ans += Sum;

        used[b[i-1].second] = 1;
        Sum += b[i-1].first;

        cout << Ans << '\n';
    }

    for(; i<=n; ++i) cout << 0 << '\n';

    return 0;
}
