#include <bits/stdc++.h>
#define mid ((st+dr)>>1)
#define left_son (node<<1)
#define right_son ((node<<1)|1)

using namespace std;

typedef pair<int,int> Pair;
typedef long long ll;
const int Nmax = 2e5 + 5;

int n, L, bestx1[Nmax], bestx2[Nmax];
ll sumy[Nmax];
pair<int,int> b[Nmax];

struct ec
{
    int x, y;
    bool operator < (const ec &other) const
    {
        return y > other.y;
    }

    ll get_val(int K) { return (ll) K * x + y; }
};
ec a[Nmax];

bool cmp(pair<ec, int> a, pair<ec, int> b)
{
    if(a.first.x == b.first.x) return a.first.y > b.first.y;
    return a.first.x < b.first.x;
}

bool wrong(ec A, ec B, ec C)
{
    return (ll) (B.y - A.y) * (A.x - C.x) >= (ll) (C.y - A.y) * (A.x - B.x);
}

struct batch
{
    vector< pair<ec, int> > v;

    void solve()
    {
        sort(v.begin(), v.end(), cmp);
        vector< pair<ec, int> > w; w = v; v.clear();

        for(auto it : w)
        {
            ec now = it.first;
            if(v.size() && v.back().first.x == now.x) continue;
            while(v.size() >= 2 && wrong(v[v.size()-2].first, v.back().first, now)) v.pop_back();
            v.push_back(it);
        }
    }

    pair<ll, int> query(int K)
    {
        while( v.size() >= 2 && v.back().first.get_val(K) < v[v.size()-2].first.get_val(K))
            v.pop_back();

        if(v.empty()) return {-1e18, 0};

        ll K1; int K2;
        K1 = v.back().first.get_val(K);
        K2 = v.back().second;
        return make_pair(K1, K2);
    }
};


class Segtree
{
    batch a[Nmax<<2];
public:

    void add(int node, int st, int dr, int pos, ec A)
    {
        a[node].v.push_back({A, pos});
        if(st == dr) return;

        if(pos <= mid) add(left_son, st, mid, pos, A);
            else add(right_son, mid+1, dr, pos, A);
    }

    pair<ll,int> query(int node, int st, int dr, int L, int R, int K)
    {
        if(L > R) return {-1e18, 0};

        if(L <= st && dr <= R) return a[node].query(K);

        pair<ll, int> P1, P2;
        P1 = P2 = {-1e18, 0};

        if(L <= mid) P1 = query(left_son, st, mid, L, R, K);
        if(mid < R) P2 = query(right_son, mid+1, dr, L, R, K);
        return max(P1, P2);
    }

    void build(int node, int st, int dr)
    {
        a[node].solve();
        if(st == dr) return;
        build(left_son, st, mid);
        build(right_son, mid+1, dr);
    }

} aint;

int main()
{
   // freopen("input", "r", stdin);
  //  freopen("output", "w", stdout);
    cin.sync_with_stdio(false);

    int i;
    cin >> n >> L;
    for(i=1; i<=n; ++i) cin >> a[i].y >> a[i].x;
    sort(a+1, a+n+1);

    for(i=1; i<=n; ++i)
    {
        sumy[i] = sumy[i-1] + a[i].y;
        bestx1[i] = bestx1[i-1];
        bestx2[i] = bestx2[i-1];

        int X = a[i].x;
        if(X >= bestx1[i]) bestx2[i] = bestx1[i], bestx1[i] = X;
            else if(X > bestx2[i]) bestx2[i] = X;

        aint.add(1, 1, n, i, a[i]);
    }

    aint.build(1, 1, n);

    ll ans0 = -1e18;
    for(i=1; i<=n; ++i) ans0 = max(ans0, a[i].get_val(L-1));
    cout << ans0 << '\n';

    for(i=2; i<=n && i<=L; ++i)
    {
        ll best1 = -1e18, best2 = -1e18;

        /*
        int j;
        for(j=i; j<=n; ++j)
            if(a[j].get_val(L-i) >= best1) best2 = best1, best1 = a[j].get_val(L-i);
                else if(a[j].get_val(L-i) >= best2) best2 = a[j].get_val(L-i);
        */

        auto ans1 = aint.query(1, 1, n, i, n, L-i);
        auto ans2 = max(aint.query(1, 1, n, i, ans1.second-1, L-i), aint.query(1, 1, n, ans1.second+1, n, L-i));

        best1 = ans1.first;
        best2 = ans2.first;

        ll Ans1, Ans2, Ans3;

        /// case1 : primele i din b

        Ans1 = sumy[i] + (ll) (bestx1[i] + bestx2[i]) * (L-i);

        /// case2 : primele i-1

        Ans2 = sumy[i-1] + (ll) bestx1[i-1] * (L-i) + best1;

        /// case3

        Ans3 = sumy[i-2] + best1 + best2;

        cout << max(max(Ans1, Ans2), Ans3) << '\n';
    }

    for(; i<=n; ++i) cout << 0 << '\n';

    return 0;
}
