#include <iostream>
#include <queue>
#include <cstdio>

using namespace std;

const int MAX_N = 100;
char table[MAX_N][MAX_N];

const int INF = 200;
int raw[2 + MAX_N + 2][2 + MAX_N + 2];

int& mat(const int& x, const int& y) {
  return raw[2 + x][2 + y];
}

int dx[] = {-2, -1, 1, 2, 2, 1, -1, -2};
int dy[] = {1, 2, 2, 1, -1, -2, -2, -1};

int apply_kernel(int x, int y) {
  int ans = INF;
  for (int i = 0; i < 8; i++)
    ans = min(ans, mat(x + dx[i], y + dy[i]));
  return ans;
}

typedef  pair<pair<int, int>, pair<int, int>> Node;

int f[2];
bool visited[MAX_N][MAX_N];
int color[MAX_N][MAX_N];
void cnt(int i, int j, int t = 0) {
  if (visited[i][j] > 0 || mat(i, j) == INF)
    return;
  visited[i][j] = 1;
  f[t]++;
  for (int k = 0; k < 8; k++)
    cnt(i + dx[k], j + dy[k], 1 - t);
}

void fil(int i, int j, int c) {
  if (color[i][j] > 0 || mat(i, j) == INF)
    return;
  color[i][j] = c;
  for (int k = 0; k < 8; k++)
    fil(i + dx[k], j + dy[k], 3 - c);
}

int main() {
  freopen( "input.txt", "r", stdin );

  int n, m, k;
  cin >> n >> m >> k;

  priority_queue<Node, vector<Node>, greater<Node>> q;

  for ( int i = 0; i < n; i++ ) {
    cin >> table[i];
    for (int j = 0; j < m; j++) {
      if (table[i][j] == '#')
        mat(i, j) = INF;
    }
  }

  for ( int i = -2; i < n + 2; i++ )
    for ( int j = -2; j < m + 2; j++ )
      if ( i < 0 || j < 0 || i >= n || j >= m )
        mat(i, j) = INF;


  for ( int i = 0; i < n; i++ )
    for (int j = 0; j < m; j++)
      if ( !visited[i][j] ) {
        f[0] = f[1] = 0;
        cnt(i, j, 0);
        if (f[0] < f[1])
          fil(i, j, 1);
        else
          fil(i, j, 2);
      }

  for ( int i = 0; i < n; i++ )
    for (int j = 0; j < m; j++)
      if (table[i][j] == '.')
        q.push( { {0, color[i][j]}, { i, j } } );

  vector<pair<int, int>> sol;
  while ( q.top().first.first <= k ) {
    Node t = q.top();
    q.pop();

    int i = t.second.first;
    int j = t.second.second;
    mat(i, j) = apply_kernel(i, j) + 1;
//    cerr << i << ' ' << j << ' ' << t.first << endl;
    q.push( { {mat(i, j), color[i][j]}, {i, j} } );
    sol.push_back( {i, j} );
  }

  cout << sol.size() << '\n';
  for ( int i = 0; i < sol.size(); i++ )
    cout << sol[i].first << ' ' << sol[i].second << '\n';
  return 0;
}
