#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

const int MAX_N = 1e5;
int a[MAX_N], b[MAX_N];

int a_sorted[MAX_N];
int va[MAX_N];
int vb[MAX_N];
long long spa[MAX_N];
int b_sorted[MAX_N];

int n, l;


bool cmp_a(int x, int y) {
  return (a[x] != a[y] ? a[x] > a[y] : b[x] > b[y]);
}
bool cmp_b(int x, int y) {
  return (b[x] != b[y] ? b[x] > b[y] : a[x] > a[y]);
}

long long linear(int i, int x) {
  return a[i] + 1LL * b[i] * x;
}

int main() {
  freopen( "input.txt", "r", stdin );
  cin >> n >> l;
  for ( int i = 0; i < n; i++ )
    cin >> a[i] >> b[i];
  for ( int i = 0; i < n; i++ )
    a_sorted[i] = b_sorted[i] = i;

  sort(a_sorted, a_sorted + n, cmp_a);
  sort(b_sorted, b_sorted + n, cmp_b);

  for ( int i = 1; i <= n; i++ )
    spa[i] = spa[i - 1] + a[a_sorted[i - 1]],
    va[i - 1] = a[a_sorted[i - 1]],
    vb[i - 1] = b[a_sorted[i - 1]];

//  for (int i = 0; i < n; i++ )
//    cerr << va[i] << ' ' << vb[i] << endl;

  for ( int k = 1; k <= n; k++ ) {
    long long ans = 0;
    if ( k == 1 ) {
      for (int i = 0; i < n; i++)
        ans = max(ans, linear(i, l - 1));
    } else if (k == 2) {
      long long m1 = 0, m2 = 0;
      for ( int i = 0; i < n; i++) {
        long long x = linear(i, l - 2);
        if ( x >= m1 ) m2 = m1, m1 = x;
        else if (x >= m2) m2 = x;
      }
      ans = m1 + m2;
    } else if ( k <= l ) {
      for ( int i = 0; i < n; i++ ) {
        for ( int j = i + 1; j < n; j++ ) {
          long long r = 1LL * (l - k) * (vb[i] + vb[j]) + spa[k - 2];
//          cout << i << ' ' << j << ": " << r << endl;
          if ( i < k - 2 )
            r += va[k - 2];
          else
            r += va[i];
          if ( j < k - 2+ (i < k) )
            r += va[k - 1];
          else
            r += va[j];
//          cout << i << ' ' << j << ": " << r << endl;
          ans = max(r, ans);
        }
      }
//      int max1 = a_sorted[0], max2 = a_sorted[1];
//      ans += a[max1] + a[max2];
//      if ( b[max2] > b[max1] ) swap(max1, max2);
//      for ( int j = 2; j < k; j++ ) {
//        int i = a_sorted[j];
//        ans += a[i];
//        if ( b[i] >= b[max1] ) max2 = max1, max1 = i;
//        else if ( b[i] > b[max2] ) max2 = i;
//      }
//      for ( int j = k; j < n; j++ ) {
//        int i = a_sorted[j];
//        if ( linear( i, l - k ) >= linear( max1, l - k ) ) {
//          ans -= a[max2];
//          ans += a[i];
//          max2 = max1;
//          max1 = i;
//        } else if ( linear( i, l - k ) >= linear( max2, l - k) ) {
//          ans -= a[max2];
//          ans += a[i];
//          max2 = i;
//        }
//      }
////      cerr << k << ": " << max1 << ' ' << max2 << endl;
//      ans += 1LL * (b[max1] + b[max2]) * (l - k);
    }
    cout << ans << '\n';
  }

  return 0;
}
