#include <bits/stdc++.h>

using namespace std;

typedef long long LL;

struct line
{
    LL a = 0LL, b = 0LL;

    line() {};
    line(LL x, LL y) { a = x, b = y; }

    LL operator()(LL x)
    {
        return this->a * x + this->b;
    }
};

int N, L;
int a[100005], b[100005], f[100005];
LL suma[100005];
int ordb[100005], orda[100005], posa[100005], posb[100005];
LL res[100005];
LL queries[100005][5];

class LiChao
{
public:
    LL best, best2;
    line aint[800005], sec[800005];

    void build(int nod, int st, int dr)
    {
        aint[nod] = sec[nod] = line(0, (-1LL << 60));
        if(st == dr)    return;
        int mij = st + (dr - st) / 2;
        build(nod * 2, st, mij);
        build(nod * 2 + 1, mij + 1, dr);
    }

    void update(int nod, int st, int dr, line l)
    {
        if(st > dr) return;
        int mij = st + (dr - st) / 2;
        LL val = l(mij);
        LL val1 = aint[nod](mij), val2 = sec[nod](mij);
        if(val > val1)
        {
            swap(l, sec[nod]);
            swap(sec[nod], aint[nod]);
        }
        else if(val > val2)
            swap(l, sec[nod]);

        if(st == dr)    return;
        if(l(st) > aint[nod](st) || l(st) > sec[nod](st))   update(nod * 2, st, mij, l);
        if(l(dr) > aint[nod](dr) || l(dr) > sec[nod](dr))   update(nod * 2 + 1, mij + 1, dr, l);
    }

    void update(int a, int b)
    {
        update(1, 0, L, line(a, b));
    }

    void query(int nod, int st, int dr, int pos)
    {
        if(st > dr) return;
        int mij = st + (dr - st) / 2;

        LL val = (aint[nod])(pos);
        if(val > best) { best2 = best; best = val; }
        else if(val > best2) best2 = val;

        val = sec[nod](pos);
        if(val > best) { best2 = best; best = val; }
        else if(val > best2) best2 = val;

        if(st == dr)    return;
        if(pos <= mij)  query(nod * 2, st, mij, pos);
        else    query(nod * 2 + 1, mij + 1, dr, pos);
    }

    LL queryy(int pos, int id)
    {
        best = best2 = (-(1LL << 60));
        query(1, 0, L, pos);
        if(id == 1) return best;
        return best2;
    }
}lichao;

int main()
{
    //freopen("1.in", "r", stdin);
    //freopen("1.out", "w", stdout);

    scanf("%d%d", &N, &L);
    for(int i = 1; i <= N; i++)
        scanf("%d%d", &a[i], &b[i]), orda[i] = ordb[i] = i;

    sort(orda + 1, orda + N + 1,
         [](int x, int y) {return a[x] > a[y];});
    sort(ordb + 1, ordb + N + 1,
         [](int x, int y) {return b[x] > b[y];});

    for(int i = 1; i <= N; i++)
    {
        posa[ orda[i] ] = i;
        posb[ ordb[i] ] = i;
    }

    LL best = 0LL;
    for(int i = 1; i <= N; i++)
        best = max(best, 1LL * a[i] + 1LL * (L - 1) * b[i]);
    res[1] = best;

    for(int i = 1; i <= N; i++)
        suma[i] = suma[i - 1] + a[ orda[i] ];

    lichao.build(1, 0, L);

    for(int k = 2; k <= N; k++)
    {
        if(k > L)   { res[k] = 0; continue; }

        int lib = L - k;

        queries[k][0] = lichao.queryy(lib, 1);
        queries[k][1] = lichao.queryy(lib, 2);
        lichao.update(b[ orda[k - 1] ], 0LL);

    }

    lichao.build(1, 0, L);
    lichao.update(b[ orda[N] ], a[ orda[N] ]);
    for(int k = N; k >= 2; k--)
    {
        int lib = L - k;
        if(k > L)   queries[k][4] = lichao.queryy(lib, 1);

        lichao.update(b[ orda[k - 1] ], a[ orda[k - 1] ]);

        if(k > L)   { res[k] = 0; continue; }


        queries[k][2] = lichao.queryy(lib, 1);
        queries[k][3] = lichao.queryy(lib, 2);
    }

    for(int k = 2; k <= N; k++)
    {
        if(k > L)   { res[k] = 0; continue; }

        int lib = L - k;

        res[k] = 0;
        res[k] = max(res[k], queries[k][0] + queries[k][1] + suma[k]);
        res[k] = max(res[k], queries[k][2] + queries[k][3] + suma[k - 2]);
        res[k] = max(res[k], queries[k][0] + 1LL * b[ orda[k - 1] ] + suma[k]);
        res[k] = max(res[k], queries[k][0] + queries[k][4] + suma[k - 1]);
    }

    for(int i = 1; i <= N; i++)
        printf("%lld\n", res[i]);

    return 0;
}
