#include <bits/stdc++.h>

using namespace std;

typedef pair<int, int> pii;

const int cx[] = {-2, -2, +2, +2, -1, +1, -1, +1};
const int cy[] = {-1, +1, -1, +1, -2, -2, +2, +2};

int N, M, K;
int f[100005], part[100005];
char a[105][105];
vector<pii> moves;
vector<int> edg[100005];
vector<int> nodes[100005];
vector<int> pp[2];

int getid(int x, int y)
{
    return M * x + y;
}

pii getcell(int id)
{
    pii r = {id / M, id % M};
    return r;
}

int F(int x)
{
    if(f[x] == x)   return x;
    return f[x] = F(f[x]);
}

void unite(int x, int y)
{
    int fx = F(x), fy = F(y);
    if(fx == fy)    return;
    f[fy] = fx;
}

void DFS(int nod, int p)
{
    if(part[nod] != -1)
    {
        assert(part[nod] == p);
        return;
    }

    part[nod] = p;
    for(auto nxt: edg[nod])
        DFS(nxt, p ^ 1);
}

void solve(vector<int> nodes)
{
    if(nodes.empty())   return;
    if(nodes.size() == 1)
    {
        moves.push_back(getcell(nodes[0]));
        return;
    }
    for(auto &x: nodes) part[x] = -1;
    DFS(nodes[0], 0);

    pp[0].clear(), pp[1].clear();
    for(auto x: nodes)  pp[ part[x] ].push_back(x);

    if(pp[0].size() > pp[1].size()) swap(pp[0], pp[1]);

    for(int i = 1; i <= K; i++)
    {
        for(auto x: pp[0])  moves.push_back(getcell(x));
        for(auto x: pp[1])  moves.push_back(getcell(x));
    }
    if(K % 2 != 0)
    for(auto x: pp[0])  moves.push_back(getcell(x));
}

int main()
{
    //freopen("1.in", "r", stdin);
    //freopen("1.out", "w", stdout);

    scanf("%d%d%d\n", &N, &M, &K);
    for(int i = 0; i < N; i++)
        scanf("%s\n", a[i]);

    for(int i = 0; i < N * M; i++)
        f[i] = i;

    for(int i = 0; i < N; i++)
        for(int j = 0; j < M; j++)
            if(a[i][j] == '.')
            {
                for(int k = 0; k < 8; k++)
                {
                    int nx = i + cx[k];
                    int ny = j + cy[k];
                    if(nx < 0 || ny < 0 || nx >= N || ny >= M)  continue;
                    if(a[nx][ny] != '.')    continue;

                    unite( getid(i, j), getid(nx, ny) );
                    edg[getid(i, j)].push_back(getid(nx, ny));
                }
            }

    for(int i = 0; i < N; i++)
        for(int j = 0; j < M; j++)
            if(a[i][j] == '.')
                nodes[ F(getid(i,j)) ].push_back(getid(i,j));

    for(int i = 0; i < N * M; i++)
        solve(nodes[i]);

    printf("%d\n", moves.size());
    for(auto &x: moves)
        printf("%d %d\n", x.first, x.second);

    return 0;
}
