#include <bits/stdc++.h>

//#define DEBUG

#ifndef DEBUG
#include "park.h"
#endif

using namespace std;

typedef pair<int, int> pii;

#ifdef DEBUG
bool get_xor(const vector<pii> &edges);
void state_direction(const pii &edge, bool direction);
#endif

int NN;
int q = 0;
int val[1000005][2];
int edg[1000005];
int in[1000005], out[1000005];

bool getxor(vector<pii> &ee)
{
    q++;
    if(q > 3 * NN)  exit(1);
    return get_xor(ee);
}

void run(int N)
{
    NN = N;

    for(int i = 1; i <= 2 * N + 2; i++)
        val[i][0] = val[i][1] = -1;
    val[1][0] = val[1][1] = 1;
    val[2 * N + 1][0] = 1;
    val[2 * N][1] = 1;

    edg[1] = 1;
    vector<pii> ee;
    for(int i = 2; i < 2 * N + 2; i++)
    {
        if(val[i][0] == -1)
        {
            ee.clear();
            ee.push_back({i, i + 1});
            val[i][0] = getxor(ee);
        }
        edg[i] = val[i][0];
    }

    for(int i = 1; i < 2 * N + 2; i++)
    {
        if(edg[i] == 1)
        {
            out[i]++;
            in[i + 1]++;
        }
        else
        {
            out[i + 1]++;
            in[i]++;
        }
    }
    out[1]++;
    in[3]++;
    out[2 * N]++;
    in[2 * N + 2]++;


    for(int i = 2; i <= 2 * N - 1; i++)
    {
        if(edg[i] == edg[i + 1])
        {
            val[i][1] = val[i][0];
            if(val[i][1] == 1)
            {
                out[i]++;
                in[i + 2]++;
            }
            else
            {
                out[i + 2]++;
                in[i]++;
            }
        }
    }

    bool changes = true;
    while(changes)
    {
        changes = false;
        if(val[2][1] == -1 && out[2] == 0 && in[2] > 1)
        {
            changes = true;
            val[2][1] = 1;
            out[2]++;
            in[4]++;
        }
        for(int i = 3; i <= 2 * N - 1; i++)
            if(val[i][1] == -1)
            {
                if(in[i] + out[i] == 3 && (in[i] == 0 || out[i] == 0))
                {
                    if(in[i] == 0)
                    {
                        val[i][1] = 0;
                        in[i]++;
                        out[i + 2]++;
                    }
                    else
                    {
                        val[i][1] = 1;
                        out[i]++;
                        in[i + 2]++;
                    }
                    changes = true;
                }
            }
    }

    for(int i = 1; i <= 2 * N; i++)
    {
        if(val[i][0] == -1)
        {
            ee.clear();
            ee.push_back({i, i + 1});
            val[i][0] = (int)getxor(ee);
        }
        if(val[i][1] == -1)
        {
            ee.clear();
            ee.push_back({i, i + 2});
            val[i][1] = getxor(ee);
        }
    }

    for(int i = 1; i <= 2 * N + 1; i++)
    {
        if(val[i][0] != -1)
        {
            state_direction({i, i + 1}, val[i][0]);
        }

        if(val[i][1] != -1)
        {
            state_direction({i, i + 2}, val[i][1]);
        }
    }

}

#ifdef DEBUG
const int __MAX_N=1e5+10;
int __n;
bool __direction[__MAX_N*4+1];

bool __invalid;
bool __incorrect;
bool __missing;
bool __stated[__MAX_N*4+1];
int __queries;

int __get_number(const std::pair<int, int>& edge)
{
    int f=edge.first;
    int t=edge.second;
    int num=f+t-3;
    if (t==f || t-f<-2 || t-f>2 || num<0 || num>4*__n) return -1;
    return num;
}
std::pair<int, int> __get_edge(int num)
{
    int f,t;
    f=num/2+1;
    t=f+1+num%2;
    return {f,t};
}
bool get_xor(const std::vector<std::pair<int, int>>& edges)
{
    ++__queries;
    bool curr_xor=false;
    int num;
    for (int i=0; i<edges.size(); ++i)
    {
        num=__get_number(edges[i]);
        if (num==-1)
        {
            std::cerr<<"Your program asked for a non NON-EXISTENT edge "<<edges[i].first<<" - "<<edges[i].second<<".\n";
            if (!__invalid && !__incorrect) __invalid=true;
            return 0;
        }
        curr_xor^=__direction[num];
    }
    std::cerr<<"Your program asked for a XOR and the answer is "<<curr_xor<<".\n";
    return curr_xor;
}
void state_direction(const std::pair<int, int>& edge, bool direction)
{
    int num=__get_number(edge);
    if (num==-1)
    {
        std::cerr<<"Your program stated the direction of a NON-EXISTENT edge "<<edge.first<<" - "<<edge.second<<" to be "<<direction<<".\n";
        if (!__invalid && !__incorrect) __invalid=true;
    }
    else
    {
        __stated[num]=true;
        if (__direction[num]!=direction)
        {
            std::cerr<<"Your program WRONGLY stated the direction of the edge "<<edge.first<<" - "<<edge.second<<" to be "<<direction<<".\n";
            if (!__invalid && !__incorrect) __incorrect=true;
        }
        else
        {
            std::cerr<<"Your program CORRECTLY stated the direction of the edge "<<edge.first<<" - "<<edge.second<<" to be "<<direction<<".\n";
        }
    }
}
void __get_input_data()
{
    freopen("1.in", "r" ,stdin);

    //std::cerr<<"N: ";
    std::cin>>__n;
    std::pair<int, int> edge;
    for (int i=0; i<4*__n+1; ++i)
    {
        edge=__get_edge(i);
        //std::cerr<<edge.first<<" - "<<edge.second<<": ";
        std::cin>>__direction[i];
    }
}
void __check_all()
{
    for (int i=0; i<4*__n+1; ++i)
    {
        if (!__stated[i])
        {
            std::pair<int, int> edge=__get_edge(i);
            std::cerr<<"Your program DIDN'T state the direction of "<<edge.first<<" - "<<edge.second<<".\n";
            if (!__invalid && !__incorrect) __missing=true;
        }
    }
}
void __verdict()
{
    if (__invalid)
    {
        std::cerr<<"Wrong Answer: Your program asked for an invalid edge.\n";
    }
    else if (__incorrect)
    {
        std::cerr<<"Wrong Answer: Your program incorrectly stated the direction of an edge.\n";
    }
    else if (__missing)
    {
        std::cerr<<"Wrong Answer: Your program didn't state the directions of all edges.\n";
    }
    else
    {
        int ST1=3*__n;
        int ST2=2*__n;
        int ST3=3*__n/2;
        if (3*__n%2) ++ST3;
        int ST4=16*__n/11;
        if (16*__n%11) ++ST4;

        if (__queries>ST1)
        {
            std::cerr<<"Wrong Answer: Your program used too many ("<<__queries<<") queries.\n";
        }
        else if (__queries>ST2)
        {
            std::cerr<<"OK: Your program used "<<__queries<<" queries - subtask 1"<<".\n";
        }
        else if (__queries>ST3)
        {
            std::cerr<<"OK: Your program used "<<__queries<<" queries - subtask 2"<<".\n";
        }
        else if (__queries>ST4)
        {
            std::cerr<<"OK: Your program used "<<__queries<<" queries - subtask 3"<<".\n";
        }
        else
        {
            std::cerr<<"OK: Your program used "<<__queries<<" queries - subtask 4"<<".\n";
        }
    }
}
int main()
{
    __get_input_data();
    run(__n);
    __check_all();
    __verdict();
    return 0;
}

#endif
