#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct line
{
	int k, b;
	line()
	{
	}
	line(int k, int b): k(k), b(b)
	{
	}
};

long double inter(const line &a, const line &b)
{
	return (a.b - b.b) / (long double) (b.k - a.k);
}

ll f(const line &a, ll x)
{
	return a.k * x + a.b;
}

bool operator < (const line &a, const line &b)
{
	if (a.k != b.k) return a.k < b.k;
	return a.b < b.b;
}

void add(vector <line> &p, line c)
{
	while (p.size() > 1)
	{
		if (p.back().k == c.k)
		{
			p.pop_back();
			continue;
		}
		auto a = p[(int) p.size() - 2];
		auto b = p.back();
		if (inter(a, b) >= inter(b, c))
		{
			p.pop_back();
		}
		else
		{
			break;
		}
	}
	p.push_back(c);
}

const int N = 1e5 + 7;

vector <line> t[4 * N];
int ptr[4 * N];

void build(int v, int l, int r, const vector <pair <int, int> > &e)
{
	if (r - l == 1)
	{
		t[v].push_back(line(e[l].second, e[l].first));
	}
	else
	{
		int m = (l + r) / 2;
		build(v * 2 + 1, l, m, e);
		build(v * 2 + 2, m, r, e);
		t[v].resize(t[v * 2 + 1].size() + t[v * 2 + 2].size());
		merge(t[v * 2 + 1].begin(), t[v * 2 + 1].end(), t[v * 2 + 2].begin(), t[v * 2 + 2].end(), t[v].begin());
		vector <line> me;
		for (auto c : t[v])
		{
			add(me, c);
		}
		t[v] = me;
	}
}

ll res(int v, ll x)
{
	while (ptr[v] + 1 < (int) t[v].size() && f(t[v][ptr[v] + 1], x) > f(t[v][ptr[v]], x))
	{
		ptr[v]++;
	}
	while (ptr[v] - 1 >= 0 && f(t[v][ptr[v] - 1], x) > f(t[v][ptr[v]], x))
	{
		ptr[v]--;
	}
	return f(t[v][ptr[v]], x);
}

ll f1(int v, int l, int r, int tl, int tr, ll x)
{
	if (tl >= r || tr <= l)
	{
		return -1e18;
	}
	if (tl >= l && tr <= r)
	{
		return res(v, x);
	}
	else
	{
		int tm = (tl + tr) / 2;
		return max(f1(v * 2 + 1, l, r, tl, tm, x), f1(v * 2 + 2, l, r, tm, tr, x));
	}
}

int opt(int v, int l, int r, int tl, int tr, ll x, ll need)
{
	if (tl >= r || tr <= l || res(v, x) < need)
	{
		return -1;
	}
	if (tr - tl == 1)
	{
		return tl;
	}
	else
	{
		int tm = (tl + tr) / 2;
		int pos = opt(v * 2 + 1, l, r, tl, tm, x, need);
		if (pos == -1)
		{
			return opt(v * 2 + 2, l, r, tm, tr, x, need);
		}
		else
		{
			return pos;
		}
	}
}

ll f2(int v, int l, int r, int tl, int tr, ll x)
{
	if (r - l <= 1) return -1e18;
	int get = opt(v, l, r, tl, tr, x, f1(v, l, r, tl, tr, x));
	return max(f1(v, l, get, tl, tr, x), f1(v, get + 1, r, tl, tr, x));
}

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	ll l;
	cin >> n >> l;
	vector <ll> ans(n + 1);
	vector <pair <int, int> > e;
	multiset <int> cur;
	for (int i = 0; i < n; i++)
	{
		int a, b;
		cin >> a >> b;
		e.push_back({a, b});
	}
	sort(e.rbegin(), e.rend());
	build(0, 0, n, e);
	ll sum = 0;
	for (int i = 0; i <= (int) e.size(); i++)
	{
		if (i + 1 <= n)
			ans[i + 1] = max(ans[i + 1], sum + f1(0, i, n, 0, n, l - i - 1) + (cur.empty() ? 0 : *cur.rbegin() * (l - i - 1)));
		if (i + 2 <= n)
			ans[i + 2] = max(ans[i + 2], sum + f1(0, i, n, 0, n, l - i - 2) + f2(0, i, n, 0, n, l - i - 2));
		if (!cur.empty())
		{
			ans[i] = max(ans[i], sum + *cur.rbegin() * (l - i));
		}
		if (cur.size() >= 2)
		{
			ans[i] = max(ans[i], sum + *cur.rbegin() * (l - i) + *prev(--cur.end()) * (l - i));
		}
		if (i != (int) e.size())
		{
			sum += e[i].first;
			cur.insert(e[i].second);
		}
	}
	for (int i = 1; i <= n; i++)
	{
		if (i > l) cout << 0 << '\n';
		else
			cout << ans[i] << '\n';
	}
}
