#include "bits/stdc++.h"

#define int long long
#define len(v) ((int)v.size())
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << p.x << " " << p.y;
	return os;
}

void run();

signed main(int argc, char *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

struct Line {
	int k, d;
	int id;
	Line() {}
	Line(int _k, int _d, int _id) {
		k = _k;
		d = _d;
		id = _id;
	}

	ll equate(int x) {
		return (ll)k * (ll)x + (ll)d;
	}
};


struct Node {
	Line l1, l2;

	Node() {
		l1 = Line(-1, -1, -1);
		l2 = Line(-1, -1, -1);
	}
};

const int N = (1 << 19);

vector<Node> S(2 * N);

void add(int i, int tl, int tr, Line line) {
	int m = (tl + tr) / 2;
	if (S[i].l1.equate(m) < line.equate(m)) {
		swap(S[i].l1, line);
	}
	if (S[i].l2.equate(m) < line.equate(m)) {
		swap(S[i].l2, line);
	}
	if (tl + 1 != tr) {
		if (S[i].l2.equate(tl) < line.equate(tl)) {
			add(i * 2 + 1, tl, m, line);
		} else {
			add(i * 2 + 2, m, tr, line);
		}
	}
}

pair<Line, Line> query(int i, int tl, int tr, int j) {
	if (tl + 1 == tr) {
		return mp(S[i].l1, S[i].l2);
	} else {
		int m = (tl + tr) / 2;
		pair<Line, Line> cur = mp(S[i].l1, S[i].l2);
		pair<Line, Line> t;
		if (j < m) {
			t = query(i * 2 + 1, tl, m, j);
		} else {
			t = query(i * 2 + 2, m, tr, j);
		}
		if (cur.x.equate(j) < t.x.equate(j)) {
			swap(cur.x, t.x);
		}
		if (cur.y.equate(j) < t.x.equate(j)) {
			swap(cur.y, t.x);
		}
		if (cur.x.equate(j) < t.y.equate(j)) {
			swap(cur.x, t.y);
		}
		if (cur.y.equate(j) < t.y.equate(j)) {
			swap(cur.y, t.y);
		}
		return cur;
	}
}

int n, L;
vector<pii> v;
vector<Line> lines;


void run() {
	cin >> n >> L;	
	v.resize(n);
	cin >> v;
	sort(v.begin(), v.end());
	for (int i = 0; i < n; i++) {
		add(0, 0, N, Line(v[i].y, v[i].x, i));	
		lines.emplace_back(v[i].y, v[i].x, i);
	}

	vector<ll> pr(n);
	pr[0] = v[0].x;
	for (int i = 1; i < n; i++) {
		pr[i] =	pr[i - 1] + v[i].x;
	}
	for (int k = 1; k <= n; k++) {
		int free = L - k;	
		// auto t = query(0, 0, N, free);
		// Line l1, l2;
		// tie(l1, l2) = query(0, 0, N, free);
		Line l1(-1, -1, -1);
		Line l2(-1, -1, -1);
		for (Line l : lines) {
			if (l1.equate(free) < l.equate(free)) {
				swap(l1, l);
			}
			if (l2.equate(free) < l.equate(free)) {
				swap(l2, l);
			}
		}
		if (k == 1) {
			cout << l1.equate(free) << "\n";	
			continue;
		}
		if (free < 0) {
			cout << 0 << "\n";
			continue;
		}
		ll rez = l1.equate(free) + l2.equate(free);
		// cout << "! " << free << endl;
		// cout << t.x.k << " " << t.
		int cnt = k - 2;
		for (int j = 0; j < n && cnt; j++) {
			if (j == l1.id || j == l2.id) continue;
			rez += v[j].x;
			cnt--;
		}
		cout << rez << "\n";
	}	
}