#include "bits/stdc++.h"

#define int long long
#define len(v) ((int)v.size())
#define mp make_pair
#define mt make_tuple
#define x first
#define y second
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << p.x << " " << p.y;
	return os;
}

void run();

signed main(int argc, char *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

struct Line {
	int k, d;
	int id;
	Line() {}
	Line(int _k, int _d, int _id) {
		k = _k;
		d = _d;
		id = _id;
	}

	ll equate(int x) {
		return (ll)k * (ll)x + (ll)d;
	}
};


struct Node {
	Line l1, l2;

	Node() {
		l1 = Line(-1, -1, -1);
		l2 = Line(-1, -1, -1);
	}
};

const int N = (1 << 20);

vector<Node> S(2 * N);

void add(int i, int tl, int tr, Line line) {
	int m = (tl + tr) / 2;
	if (S[i].l1.equate(m) < line.equate(m)) {
		swap(S[i].l1, line);
	}
	if (S[i].l2.equate(m) < line.equate(m)) {
		swap(S[i].l2, line);
	}
	if (tl + 1 != tr) {
		if (S[i].l2.equate(tl) < line.equate(tl)) {
			add(i * 2 + 1, tl, m, line);
		} else {
			add(i * 2 + 2, m, tr, line);
		}
	}
}

pair<Line, Line> query(int i, int tl, int tr, int j) {
	if (tl + 1 == tr) {
		return mp(S[i].l1, S[i].l2);
	} else {
		int m = (tl + tr) / 2;
		pair<Line, Line> cur = mp(S[i].l1, S[i].l2);
		pair<Line, Line> t;
		if (j < m) {
			t = query(i * 2 + 1, tl, m, j);
		} else {
			t = query(i * 2 + 2, m, tr, j);
		}
		if (cur.x.equate(j) < t.x.equate(j)) {
			swap(cur.x, t.x);
		}
		if (cur.y.equate(j) < t.x.equate(j)) {
			swap(cur.y, t.x);
		}
		if (cur.x.equate(j) < t.y.equate(j)) {
			swap(cur.x, t.y);
		}
		if (cur.y.equate(j) < t.y.equate(j)) {
			swap(cur.y, t.y);
		}
		return cur;
	}
}

int n, L;
vector<pii> v;
vector<Line> lines;


void update(pair<Line, Line> &p, Line l, int j) {
	if (p.x.id == l.id || p.y.id == l.id) return; 
	if (p.x.equate(j) < l.equate(j)) {
		swap(p.x, l);
	}
	if (p.y.equate(j) < l.equate(j)) {
		swap(p.y, l);
	}
}

void run() {
	cin >> n >> L;	
	v.resize(n);
	cin >> v;
	sort(v.begin(), v.end());
	reverse(v.begin(), v.end());
	vector<pii> mx(n);
	for (int i = 0; i < n; i++) {
		// add(0, 0, N, Line(v[i].y, v[i].x, i));	
		lines.emplace_back(v[i].y, v[i].x, i);
	}
	// cout << v << endl;

	vector<ll> pr(n);
	pr[0] = v[0].x;
	mx[0].x = v[0].y;
	for (int i = 1; i < n; i++) {
		pr[i] =	pr[i - 1] + v[i].x;
		mx[i] = mx[i - 1];
		int pot = v[i].y;
		if (pot > mx[i].x) {
			swap(pot, mx[i].x);
		}
		if (pot > mx[i].y) {
			swap(pot, mx[i].y);
		}
	}
	vector<ll> all;

	add(0, 0, N, Line(v[n - 1].y, v[n - 1].x, n - 1));	
	if (n > 1) {
		add(0, 0, N, Line(v[n - 2].y, v[n - 2].x, n - 2));	
	}
	deque<Line> pref;
	for (int k = n; k >= 1; k--) {
		int free = L - k;	
		// auto t = query(0, 0, N, free);
		// Line l1, l2;
		auto p = query(0, 0, N, free);
		if (k - 3 >= 0) {
			add(0, 0, N, Line(v[k - 3].y, v[k - 3].x, k - 3));
		}
		for (Line x : pref) {
			update(p, x, free);
		}
		pref.pb(p.x);
		pref.pb(p.y);
		while (len(pref) > 20) {
			pref.pop_front();
		}
		// Line l1(-1, -1, -1);
		// Line l2(-1, -1, -1);
		for (int i = max(0LL, k - 2); i < min(n, k - 2 + 20); i++) {
			Line l = lines[i];
			update(p, l, free);
			// if (l1.equate(free) < l.equate(free)) {
			// 	swap(l1, l);
			// }
			// if (l2.equate(free) < l.equate(free)) {
			// 	swap(l2, l);
			// }
		}
		Line l1 = p.x;
		Line l2 = p.y;
		if (k == 1) {
			// cout << l1.equate(free) << "\n";	
			all.pb(l1.equate(free));
			continue;
		}
		if (free < 0) {
			// cout << 0 << "\n";
			all.pb(0);
			continue;
		}
		ll rez = l1.equate(free) + l2.equate(free);
		if (k - 3 >= 0) {
			rez += pr[k - 3];
		}
		rez = max(rez, pr[k - 1] + mx[k - 1].x * free + mx[k - 1].y * free);
		if (l1.id == k - 2) {
			swap(l1, l2);
		}
		rez = max(rez, pr[k - 2] + mx[k - 2].x * free + l1.equate(free));
		// cout << rez << "\n";
		all.pb(rez);
	}	
	reverse(all.begin(), all.end());
	for (ll x : all) {
		cout << x << "\n";
	}
}