#include "bits/stdc++.h"

#define len(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << p.x << " " << p.y;
	return os;
}

void run();

signed main(int argc, char *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

int n, m, k;
vector<string> mat;
vector<vector<int>> dist;

vector<pii> shs;
bool is_cord(int x, int y) {
	return 0 <= x && x < n && 0 <= y && y < m;
}

vector<pii> del(int st) {
	vector<vector<bool>> can(n, vector<bool>(m, true));	
	vector<pii> rez;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (mat[i][j] == '#') continue;
			if ((i + j) % 2 == st) {
				rez.emplace_back(i, j);
				can[i][j] = false;
			}
		}
	}
	for (int t = 0; t < k + 1; t++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (mat[i][j] == '#') continue;
				if ((i + j + st + 1) % 2 == t % 2) {
					if (can[i][j]) {
						rez.emplace_back(i, j);
						can[i][j] = false;
						for (pii sh : shs) {
							pii sub = mp(i + sh.x, j + sh.y);
							if (is_cord(sub.x, sub.y)) {
								if (mat[sub.x][sub.y] == '#') continue;
								can[sub.x][sub.y] = true;
							}
						}
					}
				}
			}
		}
	}
	return rez;
}

vector<vector<bool>> used;
vector<vector<pii>> type(2);

void dfs(pii p) {
	used[p.x][p.y] = true;
	type[(p.x + p.y) % 2].pb(p);
	for (pii sh : shs) {
		pii sub = mp(p.x + sh.x, p.y + sh.y);
		if (is_cord(sub.x, sub.y) && mat[sub.x][sub.y] != '#' && !used[sub.x][sub.y]) {
			dfs(sub);
		} 
	}
}

void run() {
	for (int dx = -2; dx <= 2; dx++) {
		for (int dy = -2; dy <= 2; dy++) {
			if (abs(dx) + abs(dy) == 3) {
				shs.emplace_back(dx, dy);
			}
		}
	}
	cin >> n >> m >> k;
	assert(k != 1);
	mat.resize(n, string(m, '.'));
	dist.resize(n, vector<int>(m, 1e9));
	cin >> mat;
	used.resize(n, vector<bool>(m, false));
	vector<pii> rez;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (used[i][j] || mat[i][j] == '#') continue;
			type[0].clear();	
			type[1].clear();
			dfs(mp(i, j));
			if (len(type[0]) > len(type[1])) {
				swap(type[0], type[1]);
			}
			if (type[0].empty()) {
				for (pii p : type[1]) {
					rez.pb(p);
				}
			} else {
				for (int t = 0; t < k + 2; t++) {
					for (pii x : type[t % 2]) {
						rez.pb(x);
					}
				}
			}
		}
	}
	cout << len(rez) << endl;
	for (pii p : rez) {
		cout << p.x << " " << p.y << "\n";
	}
}