#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <algorithm>
#include <functional>
#include <numeric>
#include <string>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 110;
int n, m, k, a[mx][mx], used[mx][mx];
vector<pair<int, int> > d = {{1, 2}, {-1, 2}, {1, -2}, {-1, -2},
{2, 1}, {-2, 1}, {2, -1}, {-2, -1}};

vector<pair<int, int> > clr0, clr1, ans;

void push_to_ans(vector<pair<int, int> > &cur) {
	for (auto pp : cur) {
		ans.push_back(pp);
	}
}

int dfs(int x, int y, int color) {
	used[x][y] = 1;
	if (color == 0) {
		clr0.push_back({x, y});
	}
	else {
		clr1.push_back({x, y});
	}
	for (auto pp : d) {
		int x1 = x + pp.first;
		int y1 = y + pp.second;
		if (0 <= x1 && x1 < n && 0 <= y1 && y1 < m && a[x1][y1] == 0 && used[x1][y1] == 0) {
			dfs(x1, y1, 1 - color);
		}
	}
}

void go(int x, int y) {
	dfs(x, y, 0);
	if (clr0.size() > clr1.size()) {
		swap(clr0, clr1);
	}

	if (clr0.size() == 0 && clr1.size() == 1) {
		push_to_ans(clr1);
	}
	else {
		int cur_clr = 0;
		for (int i = 0; i < k + 2; ++i) {
			if (cur_clr == 0) {
				push_to_ans(clr0);
			}
			else {
				push_to_ans(clr1);
			}
			cur_clr = 1 - cur_clr;
		}
	}

	clr0.clear();
	clr1.clear();
}

int main() {
	fast_io();
	cin >> n >> m >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char c;
			cin >> c;
			if (c == '.') {
				a[i][j] = 0;
			}
			else {
				a[i][j] = 1;
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (used[i][j] == 0 && a[i][j] == 0) {
				go(i, j);
			}
		}
	}

	if (m != 2) {
		assert(0);
	}

	cout << ans.size() << endl;
	for (auto pp : ans) {
		cout << pp.first << " " << pp.second << endl;
	}
}
