#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ld EPS = 1e-7;
const ld PI = acos(-1);

#define all(x) x.begin(), x.end()
#define size(x) (ll)x.size()
#define mp(a, b) make_pair(a, b)

void solve();

int main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}


void solve()
{
    int n, m, k;
    cin >> n >> m >> k;

    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    set<pair<int, int>> now;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (s[i][j] == '.') {
                now.insert(mp(i, j));
            }
        }
    }

    vector<pair<int, int>> ans;
    const int dx[] = {-2, -1, 1, 2, 2, 1, -1, -2};
    const int dy[] = {1, 2, 2, 1, -1, -2, -2, -1};

    for (int cnt = 0; cnt <= k; cnt++) {
        set<pair<int, int>> nxt;
        while (!now.empty()) {
            auto pos = now.begin();
            int xx = pos->first, yy = pos->second;
            ans.push_back(*pos);
            now.erase(pos);
            for (int i = 0; i < 8; i++) {
                int x = xx + dx[i], y = yy + dy[i];
                if (0 <= x && x < n && 0 <= y && y < m && !now.count(mp(x, y)) && s[x][y] != '#') {
                    nxt.insert(mp(x, y));
                }
            }
        }
        now.swap(nxt);
    }

    cout << size(ans) << "\n";
    for (auto p: ans) cout << p.first << " " << p.second << "\n";
}
