#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ld EPS = 1e-7;
const ld PI = acos(-1);

#define all(x) x.begin(), x.end()
#define size(x) (ll)x.size()
#define mp(a, b) make_pair(a, b)
#define f first
#define s second

void solve();

int main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}


void solve()
{
    int n, l;
    cin >> n >> l;

    ll one = 0;
    vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].f >> v[i].s;
        one = max(one, v[i].f + v[i].s * (l - 1));
    }

    sort(all(v));

    vector<ll> suf(n + 1, 0);

    for (int i = n - 1; i >= 0; i--) {
        suf[i] = suf[i + 1] + v[i].f;
    }

    cout << one << "\n";
    for (int person = 2; person <= n; person++) {
        if (person > l) {
            cout << 0 << "\n";
            continue;
        }

        ll ans = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                ll now = v[i].f + v[i].s * (l - person) + v[j].f + v[j].s * (l - person);
                int need = person - 2;
                ll bonus = 0;
                if (j >= n - need) need--, bonus -= v[i].f;
                if (i >= n - need) need--, bonus -= v[j].f;
                now += suf[n - need] + bonus;
                ans = max(ans, now);
            }
        }

        cout << ans << "\n";
    }
}
