#include <bits/stdc++.h>
#define coutV(v) for (const auto& e: v) {cout << e << " ";} cout << "\n"

using namespace std;

int N, M, K;
vector<vector<bool>> board;

// N == y, M == x
vector<pair<int, int>> shots;
bool shoot(int y, int x) {
	if (!board[y][x]) {
		shots.push_back({x, y});
		return true;
	} else {
		cerr << "Position " << y << " " << x << " is blocked.\n";
		return false;
	}
}

void output() {
	cout << shots.size() << "\n";
	for (const auto& shot: shots) {
		cout << shot.first << " " << shot.second << "\n";
	}
	exit(0);
}

//

int calculateMaxLives(int y, int x, const vector<vector<int>>& lives) {
	int maxNewLives = 0;
	
	vector<pair<int, int>> nextPos = {{y-2,x-1}, {y-2, x+1}, {y-1, x-2}, {y-1, x+2}, {y+2,x-1}, {y+2, x+1}, {y+1, x-2}, {y+1, x+2}};
	
	for (pair<int, int> p: nextPos) {
		if ((p.first < N && p.first >= 0) && (p.second < M && p.second >= 0)) {
			maxNewLives = max(maxNewLives, lives[p.first][p.second]);
		}
	}
	
	return maxNewLives;
}

void generateRandomShootingSequence(int ct) {
	vector<pair<int, int>> minShots = shots;
	
	vector<vector<int>> iLives = vector<vector<int>>(N, vector<int>(M, K + 1));
	for (int x = 0; x < M; x++) {
		for (int y = 0; y < N; y++) {
			if (board[y][x]) {
				iLives[y][x] = 0;
			}
		}
	}
	
	for (int _ct = 0; _ct < ct; _ct++) {
		auto lives = iLives;
		bool canShoot = true;
		
		do {
			canShoot = false;
			
			for (int __a = 0; __a < N * M; __a++) {
				
				int x = rand() % M;
				int y = rand() % N;
				
				if (lives[y][x] > 0) {
					shoot(y, x);
					lives[y][x] = calculateMaxLives(y, x, lives) - 1;
				}
			
			}
			
			for (int x = 0; x < M; x++) {
				for (int y = 0; y < N; y++) {
					if (lives[y][x] > 0) {
						canShoot = true;
						goto whileLoop;
					}
				}
			}
			
			whileLoop:;
		} while (canShoot);
		
		if (minShots.size() == 0) {
			minShots = shots;
		} else if (minShots.size() > shots.size()){
			minShots = shots;
		}
	}

	shots = minShots;
}

signed main() {
	
	srand(2704000);
	
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	
	cin >> N >> M >> K;
	
	board.assign(N, vector<bool>(M, false));
	
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < M; j++) {
			char c;
			cin >> c;
			board[i][j] = (c == '#');
		}
	}
	
	// Case width or height == 1
	if (M == 1) {
		for (int i = 0; i < N; i++) {
			shoot(i, 0);
		}
		
		output();
	} else if (N == 1) {
		for (int i = 0; i < M; i++) {
			shoot(0, i);
		}
		
		output();
	}
	
	// Solve M == 2
	if (M == 2) {
		vector<vector<int>> lives = vector<vector<int>>(N, vector<int>(M, K + 1));
		
		for (int x = 0; x < M; x++) {
			for (int y = 0; y < N; y++) {
				if (board[y][x]) {
					lives[y][x] = 0;
				}
			}
		}

		bool didShoot = true;
		while (didShoot) {
			didShoot = false;
			
			for (int x = 0; x < M; x++) {
				for (int y = 0; y < N; y++) {
					if (lives[y][x] > 0) {
						shoot(y, x);
						lives[y][x] = calculateMaxLives(y, x, lives) - 1;
						didShoot = true;
					}
				}
			}
		}
		
		//cout << "A: " << shots.size() << "\n";
	}
	
	generateRandomShootingSequence(2000);
	
	// Output
	output();
	
	return 0;
}
