#include <iostream>
#include <cstdint>
#include <algorithm>
#include <vector>
using namespace std;

//nondebug only:
#define endl '\n'

vector<pair<pair<uint32_t, uint32_t>, uint32_t>> vh;
vector<uint64_t> prsa;
uint32_t l;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint32_t n;
    cin>>n>>l;
    if(n>200)
    {
        exit(0);
    }
    vh.resize(n);
    prsa.resize(vh.size()+1);
    prsa[0]=0;
    for(uint32_t i=0; i<vh.size(); i++)
    {
        cin>>vh[i].first.first>>vh[i].first.second;
        vh[i].second=i;
    }
    sort(vh.begin(), vh.end(), greater<pair<pair<uint32_t, uint32_t>, uint32_t>>());
    for(uint32_t i=0; i<vh.size(); i++)
        prsa[i+1]=prsa[i]+vh[i].first.first;
}

void show()
{
    for(uint32_t i=0; i<vh.size(); i++)
        cout<<vh[i].first.first<<' '<<vh[i].first.second<<' '<<vh[i].second<<endl;
    for(uint32_t i=0; i<prsa.size(); i++)
        cout<<prsa[i]<<' ';
    cout<<endl;
}

uint64_t solve(uint32_t k)
{
    uint64_t res=0;
    if(k>l)return res;
    if(k==1)
    {
        for(uint32_t i=0; i<vh.size(); i++)
            res=max(res, (uint64_t)vh[i].first.first+((uint64_t)(l-1)*(uint64_t)vh[i].first.second));
    }
    else
    {
        for(uint32_t i=0; i<vh.size()-1; i++)
        {
            for(uint32_t j=i+1; j<vh.size(); j++)
            {
                uint64_t cur_res=0;
                cur_res=((uint64_t)(l-k)*(uint64_t)(vh[i].first.second+vh[j].first.second));
                //cur_res+=(uint64_t)(vh[i].first.first+vh[j].first.first);
                //cur_res+=prsa[k-2];
                if(i>=k-2)
                {
                    cur_res+=prsa[k-2];
                    cur_res+=(uint64_t)(vh[i].first.first+vh[j].first.first);
                }
                else if(i<k-2&&j>=k-1)
                {
                    cur_res+=prsa[k-1];
                    cur_res+=(uint64_t)(vh[j].first.first);
                }
                else //if(i<k-2&&j<k-1)
                {
                    cur_res+=prsa[k];
                }

                //cout<<i<<' '<<j<<' '<<cur_res<<endl;

                res=max(res, cur_res);
            }
        }
    }

    //debug
    return res;
}

int main()
{
    init();
    //show();
    for(uint32_t i=0; i<vh.size(); i++)
        cout<<solve(i+1)<<endl;

    return 0;
}
