#include <iostream>
#include <cstdint>
#include <cstdlib>
#include <algorithm>
#include <vector>

using namespace std;

vector < vector < uint32_t > > ss;

vector <bool> used;

uint32_t bits_reverse(uint32_t n, uint32_t num)
{
    uint32_t res=0;

    for(uint32_t i=0; i<n; i++)
    {
        res=res<<1;
        res=res|(num&1);
        num=num>>1;
    }

    return res;
}

void clear_and_generate_graph(uint32_t n, uint32_t data)
{
    ss.clear();
    ss.resize(n);
    used.clear();
    used.resize(n);
    for(uint32_t i=0; i<n-2; i++)
    {
        //cout<<"ASD "<<(data&1)<<endl;
        if(!(data&1))ss[i].push_back(i+1);
        else ss[i+1].push_back(i);
        data>>=1;
        //cout<<"ASD "<<(data&1)<<endl;
        if(!(data&1))ss[i].push_back(i+2);
        else ss[i+2].push_back(i);
        data>>=1;
    }
    if(!(data&1))ss[n-2].push_back(n-1);
    else ss[n-1].push_back(n-2);
    for(uint32_t i=0; i<n; i++)
        sort(ss[i].begin(), ss[i].end());
}

bool check_pr1()
{
    uint32_t n=ss.size();
    if(ss[0].size()!=2)return false;
    if(ss[1].size()==0&&ss[1].size()==3)return false;
    if(ss[n-2].size()==0&&ss[n-2].size()==3)return false;
    if(ss[n-1].size()!=0)return false;
    for(uint32_t i=2; i<n-2; i++)
        if(ss[i].size()==0||ss[i].size()==4)return false;

    return true;
}

bool check_pr2(uint32_t x=0)
{
    if(used[x])return false;
    used[x]=true;
    bool ok=true;
    for(uint32_t i=0; i<ss[x].size(); i++)
    {
        if(!check_pr2(ss[x][i]))
            ok=false;
    }
    used[x]=false;
    return ok;
}

bool check()
{
    return check_pr1()&&check_pr2();
}

void show()
{
    cout<<"---------------"<<endl;
    for(uint32_t i=0; i<ss.size(); i++)
    {
        cout<<i<<": ";
        for(uint32_t j=0; j<ss[i].size(); j++)
            cout<<ss[i][j]<<' ';
        cout<<endl;
    }
    cout<<"---------------"<<endl;
}

bool get_edge(pair<uint32_t, uint32_t> e)
{
    if(e.first>e.second)swap(e.first, e.second);
    return binary_search(ss[e.first].begin(), ss[e.first].end(), e.second);
}

bool get_xor(const vector<pair<uint32_t, uint32_t>> &edges)
{
    bool res=get_edge(edges[0]);
    for(uint32_t i=1; i<edges.size(); i++)
        res=res^get_edge(edges[i]);
    return res;
}

void test()
{
    vector<pair<uint32_t, uint32_t>> v, v1, v2, v3;
    v.push_back(make_pair(2, 3));
    v.push_back(make_pair(2, 4));
    v.push_back(make_pair(3, 4));
    v.push_back(make_pair(3, 5));
    v.push_back(make_pair(4, 5));
    v1.push_back(make_pair(2, 3));
    v2.push_back(make_pair(2, 4));
    v3.push_back(make_pair(3, 4));
    cout<<get_xor(v)<<' '<<get_xor(v1)<<' '<<get_xor(v2)<<' '<<get_xor(v3)<<" |";
    if(check())cout<<" This test scenario is possible"<<endl;
    else cout<<" This test scenario is impossible"<<endl;
}

int main()
{
    //exit(0);
    for(uint32_t i=0; i<512; i++)
    {
        if((i&63)==0)cout<<"------------------------"<<endl;
        uint32_t q=bits_reverse((8-2)*2+1-4, i);
        //cout<<q<<endl;
        clear_and_generate_graph(8, q);
        //show();
        if(check())
        {
            cout<<i<<" | ";
            test();
        }
    }


    return 0;
}
